//#define ERROR_TRAPPER

bool HandleCommand			(PacketStruct * Packet)
{
	_listnode <LUserNode> * user = Packet->Source->FindByID(GetLong(Packet->Message, 1));	// Trade DBase ID for Adress-space ID

	if (user)
	{
		// Exists

		// Generate message processing parameters
		LUserNode * player	= user->item;
		char	  * command	= (char*)&Packet->Message[5];
		SHORT		length	= Packet->Length - 6;

		printf("%i - %s>%s\n", Packet->Source->ScoreID, player->player->Name, command);

		// Check for command floods
		switch (player->CheckFlood())
		{
		case 2:
			// Flood detected
			{
				printf("%i - Command flooder kicked: %s\n", Packet->Source->ScoreID, player->player->Name);
				player->SendArena("NOTE: You are being disconnected for command flooding.");
				player->Kick(0, KICK_FLOOD, -1);

				return true;
			}
			break;
		case 1:
			// Flood warning
			{
				player->SendArena("No command flooding");
			}
			break;
		};

/* Error trapper */
#ifdef ERROR_TRAPPER

try
{

#endif
/* Error trapper */

			/* Hidden commands */

			if (MatchString(command, "?coin", 5))
			{
				if (DATABASE.Rnd.GetNextNumber() % 2)
				{
					player->SendArena("Heads!");
				}
				else
				{
					player->SendArena("Tails!");
				}
			}


			/* Misc. commands */

			if (MatchString(command, "?nick", 5))
			{
				if (length <= 6)
				{
					player->SendArena("SYNTAX: ?nick=<name>:<password>");

					return true;
				}

				// Find player in the re-log limiter
				{
					_listnode <RecentSource> * Attempt = DATABASE.FindSource(GetLong(Packet->Message, 2));

					if (Attempt)
					{
						switch (Attempt->item->CheckLogins())
						{
						case 2:		// 6 or more connection requests
							printf("%i - Player ?nick ignored(Flood): %s\n", Packet->Source->ScoreID, &Packet->Message[6]);

							return true;
						case 1:		// 3 or more connection requests
							player->SendArena("Busy processing ?nick requests.  Try again soon");

							printf("%i - Player ?nick refused(Light flood): %s\n", Packet->Source->ScoreID, &Packet->Message[6]);

							return true;
						};
					}
					else
					{	// Create a limiter entry since none was found
						if (DATABASE.SrcDatabase.Total > 100)
							DATABASE.SrcDatabase.Delete(DATABASE.SrcDatabase.tail, false);

						RecentSource * src = new RecentSource(player->player->IP);
						DATABASE.SrcDatabase.Prepend(src);
					}
				}

				BYTE Name[32];
				BYTE Password[32];
				memset(Name, 0, 32);
				memset(Password, 0, 32);

				// Parse input
				SHORT	LeftLength;
				char  * RightText;

				if (ColonParse(command + 6, length - 6, LeftLength, RightText))
				{
					// Find squad
					memcpy(Name, &command[6], LeftLength);
					memcpy(Password, RightText, strlen(RightText));

					SpaceTrim(Name, (char*)&Name, 20);

					if (InvalidUsername((char*)&Name))
					{
						player->SendArena("Invalid nick.  All characters must be printable");

						return true;
					}

					_listnode <User> * puser = DATABASE.FindUser(Name);

					if (puser)
					{
						User * user = puser->item;

						if (DATABASE.ValidatePassword(user, Password))
						{
							// Produce a date local to the user
							tm * CDate = Localize(&user->CreationDate, player->player->TimeZoneBias);

							// Produce a score
							_listnode <Score>	* scr_parse	= Packet->Source->ScoreDatabase.head;
							Score				* score		= NULL;

							while (scr_parse)
							{
								if (scr_parse->item->Owner == user)
								{
									score = scr_parse->item;

									break;
								}

								scr_parse = scr_parse->next;
							}

							// Produce message
							BYTE buffer[192];

							if (score)
							{
								// Has a score
								MakePlayerResponse(buffer,						// Destination buffer
												   (user->regform) ? PRMEANING_ENTER : PRMEANING_REGFORM,					// Meaning
												   player->PlayerID,				// PlayerID
												   (char*)Name,						// Player name
												   (user->squad ? user->squad->Name : NULL),			// Squad name
												   user->Banner,					// Banner
												   user->TotalSeconds,			// Total Seconds
												   (CDate ? GetYear(CDate) : 0),	// Creation Year
												   (CDate ? CDate->tm_mon + 1 : 0),	// Creation Month
												   (CDate ? CDate->tm_mday : 0),	// Creation Day
												   (CDate ? CDate->tm_hour : 0),	// Creation Hour
												   (CDate ? CDate->tm_min : 0),		// Creation Minute
												   (CDate ? CDate->tm_sec : 0),		// Creation Second
												   user->LoadID,					// Score ID
												   score->Wins,						// Wins
												   score->Losses,					// Losses
												   score->Flags,					// Goal count
												   score->Points,					// Points
												   score->EventPoints,				// Event points
												   0,								// Extra 1
												   0);								// Extra 2

								printf("%i - Player changing name: %s -> %s\n", Packet->Source->ScoreID, player->player->Name, Name);
							}
							else
							{
								// Has no score
								MakePlayerResponse(buffer,						// Destination buffer
												   (user->regform) ? PRMEANING_ENTER : PRMEANING_REGFORM,					// Meaning
												   player->PlayerID,				// PlayerID
												   (char*)Name,						// Player name
												   (user->squad ? user->squad->Name : NULL),			// Squad name
												   user->Banner,					// Banner
												   user->TotalSeconds,				// Total Seconds
												   (CDate ? GetYear(CDate) : 0),	// Creation Year
												   (CDate ? CDate->tm_mon + 1 : 0),	// Creation Month
												   (CDate ? CDate->tm_mday : 0),	// Creation Day
												   (CDate ? CDate->tm_hour : 0),	// Creation Hour
												   (CDate ? CDate->tm_min : 0),		// Creation Minute
												   (CDate ? CDate->tm_sec : 0),		// Creation Second
												   user->LoadID,					// Score ID
												   0,								// Wins
												   0,								// Losses
												   0,								// Goal count
												   0,								// Points
												   0,								// Event points
												   0,								// Extra 1
												   0);								// Extra 2

								printf("%i - Player changing name(no score): %s -> %s\n", Packet->Source->ScoreID, player->player->Name, Name);
							}

							player->player	= user;
							player->score	= score;

							Packet->Source->Send(buffer, 192, true);
						}
						else
						{
							player->SendArena("Invalid password");
						}
					}
					else	
					{
						// Create a new user
						BYTE buffer[192];

						User * user = DATABASE.AddUser(Name, Password, player->player->IP, player->player->MacID, player->player->TimeZoneBias);

						MakePlayerResponse(buffer,						// Destination buffer
										   PRMEANING_REGFORM,				// Meaning
										   player->PlayerID,				// PlayerID
										   (char*)Name,						// Player name
										   NULL,							// Squad name
										   NULL,							// Banner
										   0,								// Total Seconds
										   0,								// Creation Year
										   0,								// Creation Month
										   0,								// Creation Day
										   0,								// Creation Hour
										   0,								// Creation Minute
										   0,								// Creation Second
										   user->LoadID,					// Score ID
										   0,								// Wins
										   0,								// Losses
										   0,								// Goal count
										   0,								// Points
										   0,								// Event points
										   0,								// Extra 1
										   0);								// Extra 2

						player->score = NULL;
						player->player = user;

						Packet->Source->Send(buffer, 192, true);
					}
				}
				else
				{
					player->SendArena("SYNTAX: ?nick=<name>:<password>");
				}

				return true;
			}


			/* User detail commands */

			if (MatchString(command, "?details", 8))
			{
				if (player->player->regform)
				{
					if (length >= 9)
					{
						if (command[8] == '=')
						{
							// Set details
							char Comment[128];

							memset(Comment, 0, 128);
							memcpy(Comment, &command[9], TrimInt(length - 9, 127));
							memcpy(player->player->regform->Comment, Comment, 128);

							player->SendArena("Details changed.");
						}
						else
						{
							BYTE Name[32];

							memset(Name, 0, 32);
							SpaceTrim(Name, &command[9], 31);

							_listnode <User> * parse = DATABASE.FindUser(Name);

							if (parse)
							{
								if (parse->item->regform)
								{
									_string s;
									s = "Name: ";
									s += parse->item->regform->Name;
										player->SendArena(s.Text);
									s = "Email: ";
									s += parse->item->regform->Email;
									player->SendArena(s.Text);
									s = "Details: ";
									s += parse->item->regform->Comment;
									player->SendArena(s.Text);
								}
								else
								{
									player->SendArena("Player is unregistered.");
								}
							}
							else
							{
								player->SendArena("Unable to find specified user.");
							}
						}
					}
					else
					{	// View details
						_string s;
						s = "Name: ";
						s += player->player->regform->Name;
						player->SendArena(s.Text);
						s = "Email: ";
						s += player->player->regform->Email;
						player->SendArena(s.Text);
						s = "Details: ";
						s += player->player->regform->Comment;
						player->SendArena(s.Text);
					}
				}
				else
				{	// Registration data not found
					player->SendArena("This feature may only be used by registered players.");
				}

				return true;
			}

			if (MatchString(command, "?setname", 8))
			{
				if (player->player->regform)
				{
					if (length >= 9)
					{
						char Name[32];

						memset(Name, 0, 32);
						memcpy(Name, &command[9], TrimInt(length - 9, 31));
						memcpy(player->player->regform->Name, Name, 32);

						player->SendArena("Registered name changed.");
					}
					else
					{
						memset(player->player->regform->Name, 0, 32);
						player->SendArena("Registered name changed.");
					}
				}
				else
				{
					player->SendArena("This feature may only be used by registered players.");
				}

				return true;
			}

			if (MatchString(command, "?setemail", 9))
			{
				if (player->player->regform)
				{
					if (length >= 10)
					{
						char Email[32];

						memset(Email, 0, 32);
						memcpy(Email, &command[10], TrimInt(length - 10, 31));
						memcpy(player->player->regform->Email, Email, 32);

						player->SendArena("Registered email address changed.");
					}
					else
					{
						memset(player->player->regform->Email, 0, 32);
						player->SendArena("Registered email address changed.");
					}
				}
				else
				{
					player->SendArena("This feature may only be used by registered players.");
				}

				return true;
			}


			/* Chat channel commands */

			if (MatchString(command, "?notifychat", 8))
			{
				// Check if there is a request for a certain state.
				if (length >= 13)
				{
					switch (command[12])
					{
					case 'o':
					case 'O':
						if (length >= 14)
						{
							if (player->ChatNotify = (command[13] != 'f') && (command[13] != 'F'))
								player->SendArena("Chat notify ENABLED");
							else
								player->SendArena("Chat notify DISABLED");

							return true;
						}
					case 'y':
					case 'Y':
					case 't':
					case 'T':
					case '1':
						{
							player->SendArena("Chat notify ENABLED");
							player->ChatNotify = true;
							if (player->player->regform)
								player->player->regform->NotifyChat = 1;
						}
						return true;
					case 'n':
					case 'N':
					case 'f':
					case 'F':
					case '0':
						{
							player->SendArena("Chat notify DISABLED");
							player->ChatNotify = false;
							if (player->player->regform)
								player->player->regform->NotifyChat = 0;
						}
						return true;
					};
				}

				// Toggle if there is no preference.
				if (player->ChatNotify = !player->ChatNotify)
				{
					player->SendArena("Chat notify ENABLED");
					if (player->player->regform)
						player->player->regform->NotifyChat = 1;
				}
				else
				{
					player->SendArena("Chat notify DISABLED");
					if (player->player->regform)
						player->player->regform->NotifyChat = 0;
				}

				return true;
			}

			if (MatchString(command, "?ghost", 6))
			{
				if (player->Ghost = !player->Ghost)
					player->SendArena("Ghosting ENABLED");
				else
					player->SendArena("Ghosting DISABLED");

				return true;
			}

			if (MatchString(command, "?password", 9))
			{
				if (length <= 10)
				{
					player->SendArena("SYNTAX: ?password=<new password>");
					return true;
				}

				char buffer[32];
				memset(buffer, 0, 32);
				memcpy(buffer, &command[10], length - 10);
				HashPassword((BYTE*)buffer);
				memcpy(player->player->Password, buffer, 32);
				player->SendArena("Password changed.");

				return true;
			}

			if (MatchString(command, "?addchat", 8))
			{	// ?addchat chan, chan	- Add channels
				if (length <= 9)
					return true;

				// Parse list of channels
				BYTE buffer[512];
				bool IgnoreMore = false;

				int offset = 0;

				for (int i = 9; i < length; i++)
				{
					// These characters designate a new entry starting
					if ((command[i] == ',') || (command[i] == ' '))
					{
						IgnoreMore = false;
						// Ignore ",,,,,,,________"
						if (offset > 0)
						{
							// Add a chat
							buffer[offset] = 0;

							for (int chatindex = 1; chatindex <= 10; chatindex++)
							{
								if (chatindex == 10)
								{
									player->SendArena("Channel list full.");

									return true;
								}
								else
								{
									if (player->channels[chatindex] == NULL)
									{
										player->JoinChat(buffer, chatindex, true);

										break;
									}
								}
							}

							// Reset string parser
							offset = 0;
						}
					}
					else
					{
						if (IgnoreMore == false)
						{
							// Store a character
							buffer[offset++] = command[i];

							// Stop parsing if a channel name gets beyond 32 characters
							if (offset == 32)
								IgnoreMore = true;
						}
					}
				}

				// Add whatever is left in the buffer
				if (offset > 0)
				{
					// Add a chat
					buffer[offset] = 0;

					for (int chatindex = 1; chatindex <= 10; chatindex++)
					{
						if (chatindex == 10)
						{
							player->SendArena("Channel list full.");

							return true;
						}
						else
						{
							if (player->channels[chatindex] == NULL)
							{
								player->JoinChat(buffer, chatindex, true);

								break;
							}
						}
					}
				}

				return true;
			}

			if (MatchString(command, "?leavechat", 10))
			{
				if (length <= 11)
					return true;

				BYTE name[32];
				memset(name, 0, 32);
				SpaceTrim(name, &command[11], 31);

				if ((strlen((char*)&name[0]) == 1) && (name[0] >= 49) && (name[0] <= 57))
				{	// Assuming he means a channel #
					int id = (name[0] - 48);

					if (player->channels[id])
						player->ExitChat(id, true);
				}
				else
				{	// Assuming he's giving a channel name
					for (int id = 1; id < 10; id++)
						if ((player->channels[id]) && (strcmp((char*)&(player->channels[id]->Name)[0], (char*)&name[0]) == 0))
						{
							player->ExitChat(id, true);

							break;
						}
				}

				return true;
			}

			if (MatchString(command, "?chat", 5))
			{
				BYTE buffer[512];
				bool IgnoreMore = false;

				if ((length >= 6) && ((command[5] == ' ') || (command[5] == '=')) )
				{
					// ?chat chan, chan	- Add channels
					Chat * Channels[10];
					for (SHORT i = 0; i < 10; i++)
						if (player->channels[i] && (player->channels[i]->Participants.Total > 1))
							Channels[i] = player->channels[i];
						else
							Channels[i] = NULL;

					if (length == 6)
					{
						// The user is just closing all his channels
						player->ExitAllChats(true);

						return true;
					}
					else
					{
						player->ExitAllChats(false);
					}

					// Parse list of channels
					int offset		= 0,
						chatindex	= 1;		// There is no channel 0

					for (i = 6; i < length; i++)
					{
						// These characters designate a new entry starting
						if (command[i] == ',')
						{
							IgnoreMore = false;

							// Ignore ",,,,,,,________"
							if (offset > 0)
							{
								// Add a chat
								buffer[offset] = 0;
								BYTE Name[32];
								SpaceTrim(Name, (char*)&buffer[0], 31);

								Chat * chan = player->JoinChat(Name, chatindex, false);

								if (chan)
								{
									// Broadcast if it's a new chat, note if it is not
									bool OnList = false;
									for (SHORT x = 1; x < 10; x++)
										if (Channels[x] == chan)
										{
											Channels[x] = NULL;
											OnList = true;
											break;
										}
									if (OnList == false)
										DATABASE.BroadcastEntering(player, chan);

									// Stop parsing if all channels have been filled
									if ((chatindex++) == 9)
									{
										offset = 0;

										break;
									}
								}

								// Reset string parser
								offset = 0;
							}
						}
						else if (IgnoreMore == false)
						{
							// Store a character
							buffer[offset++] = command[i];

							// Limit chat channel lengths to 31 characters
							if (offset == 32)
								IgnoreMore = true;
						}
					}

					// Add whatever is left in the buffer
					if (offset > 0)
					{
						// Add a chat
						buffer[offset] = 0;
						BYTE Name[32];
						SpaceTrim(Name, (char*)&buffer[0], 31);

						Chat * chan = player->JoinChat(Name, chatindex, false);

						if (chan)
						{
							bool OnList = false;
							for (SHORT x = 1; x < 10; x++)
								if (Channels[x] == chan)
								{
									Channels[x] = NULL;
									OnList = true;
									break;
								}
							if (OnList == false)
								DATABASE.BroadcastEntering(player, chan);
						}
					}

					for (i = 1; i < 10; i++)
						if (Channels[i] != NULL)
							DATABASE.BroadcastLeaving(player, Channels[i]);
				}
				else
				{
					// ?chat - List players on channels

					for (int id = 1; id < 10; id++)
						if (player->channels[id])
						{
							// Write channel header
							buffer[0] = id + 48;
							buffer[1] = ')';
							buffer[2] = 0;
							strcat((char*)&buffer[0], (char*)&player->channels[id]->Name[0]);
							strcat((char*)&buffer[0], ": ");

							int count = 0;

							// Write channel body
							_listnode <Chatter> * parse = player->channels[id]->Participants.head;

							while (parse)
							{
								if (parse->item->Player->Ghost && parse->item->Player->OpStatus)
								{
									parse = parse->next;
								}
								else
								{
									strcat((char*)&buffer[0], (char*)&parse->item->Player->player->Name[0]);

									parse = parse->next;

									count++;
									if (count == 10)
									{
										player->SendArena(buffer);
										buffer[0]	= 0;
										count		= 0;
									}
									else if (parse)
										strcat((char*)&buffer[0], ",");
								}
							}

							if (count)
								player->SendArena(buffer);
						}
				}

				return true;
			}


			/* Squad commands */

			if (MatchString(command, "?squadowner", 11))
			{
				if (length <= 12)
				{
					player->SendArena("SYNTAX: ?squadowner <squad name>");
					return true;
				}

				Squad * squad = DATABASE.FindSquad((BYTE*)&command[12]);

				if (squad)
				{
					char buffer[512];

					strcpy(buffer, (char*)&squad->Name[0]);
					strcat(buffer, " owner: ");
					if (squad->Owner)
						strcat(buffer, (char*)&squad->Owner->Name[0]);
					else
						strcat(buffer, "(UNKNOWN)");

					player->SendArena(buffer);
				}
				else	
				{
					player->SendArena("Specified squad does not exist");
				}

				return true;
			}

			if (MatchString(command, "?seen", 5))
			{
				User * user;

				if (length <= 6)
				{
					user = player->player;
				}
				else
				{
					// Check player squad
					_listnode <User> * parse = DATABASE.FindUser((BYTE*)&command[6]);
					if (parse)
						user = parse->item;
					else
						user = NULL;
				}

				if (user)
				{
					_string s;

					s  = (char*)&user->Name[0];
					s += " last seen: ";
					tm * date = Localize(&user->LastLogin, player->player->TimeZoneBias);
					if (date)
					{
						s += date->tm_mon + 1;
						if (date->tm_mday < 10)
							s += "-0";
						else
							s += "-";
						s += date->tm_mday;
						s += "-";
						s += GetYear(date);
						s += " ";
							s += date->tm_hour;
						if (date->tm_min < 10)
							s += ":0";
						else
							s += ":";
						s += date->tm_min;
						if (date->tm_sec < 10)
							s += ".0";
						else
							s += ".";
						s += date->tm_sec;
					}
					else
					{
						s += "(Invalid date)";
					}

					player->SendArena(s.Text);
				}
				else
				{
					player->SendArena("Specified player does not exist.");
				}

				return true;
			}

			if (MatchString(command, "?squadjoin", 10))
			{	// ?squadjoin Name:Password
				if (length <= 11)
				{
					player->SendArena("SYNTAX: ?squadjoin=<squad name>:<squad password>");
					return true;
				}

				BYTE Name[32];
				BYTE Password[32];
				memset(Name, 0, 32);
				memset(Password, 0, 32);

				// Parse input
				SHORT	LeftLength;
				char  * RightText;

				if (ColonParse(&command[11], length - 11, LeftLength, RightText))
				{
					// Find squad
					memcpy(Name, &command[11], LeftLength);

					Squad * squad = DATABASE.FindSquad(Name);

					if (squad)
					{
						// Check password
						memcpy(Password, RightText, strlen(RightText));

						if ((squad->Owner == player->player) || DATABASE.ValidatePassword(squad, Password))
						{
							// Join squad
							if (player->player->squad)
								player->player->squad->Participants.Delete(player->player, true);
							player->player->squad = squad;
							squad->Participants.Append(player->player);

							player->SendArena("Squad successfully joined. Exit zone for it to take effect");
						}
						else
						{
							player->SendArena("Invalid password for specified squad");
						}
					}
					else	
					{
						player->SendArena("Specified squad does not exist");
					}
				}
				else
				{
					memcpy(Name, &command[11], TrimInt(length - 11, 31));

					Squad * squad = DATABASE.FindSquad(Name);

					if (squad)
					{
						if (squad->Owner == player->player)
						{
							if (player->player->squad)
								player->player->squad->Participants.Delete(player->player, true);
							player->player->squad = squad;
							squad->Participants.Append(player->player);

							player->SendArena("Squad successfully joined. Exit zone for it to take effect");
						}
						else
						{
							player->SendArena("You are not squad owner");
						}
					}
					else
					{
						player->SendArena("Specified squad does not exist");
					}
				}

				return true;
			}

			if (MatchString(command, "?squadleave", 9))
			{
				if (player->player->squad)
				{
					// Remove player from squad
					player->player->squad->Participants.Delete(player->player, true);

					// Unregister squad from player
					player->player->squad = NULL;
				}

				player->SendArena("Squad successfully left. Exit zone for it to take effect");

				return true;
			}

			if (MatchString(command, "?squadcreate", 12))
			{	// ?squadcreate Name:Password
				if (length <= 13)
				{
					player->SendArena("SYNTAX: ?squadcreate=<squad name>:<squad password>");
					return true;
				}

				BYTE Name[32];
				BYTE Password[32];
				memset(Name, 0, 32);
				memset(Password, 0, 32);

				// Parse input
				SHORT	LeftLength;
				char  * RightText;

				if (ColonParse(&command[13], length - 13, LeftLength, RightText))
				{
					// Find squad
					SpaceTrim(Name, &command[13], TrimInt(LeftLength, 31));

					if (InvalidSquadname((char*)&Name[0]))
					{
						player->SendArena("All characters in your squad's name must be printable.");

						return true;
					}

					Squad * squad = DATABASE.FindSquad(Name);

					if (!squad)
					{
						memcpy(Password, RightText, length - LeftLength - 14);
						if (player->player->squad)
							player->player->squad->Participants.Delete(player->player, true);
						DATABASE.AddSquad(Name, Password, player->player);

						player->SendArena("Squad successfully created and joined. Exit zone for it to take effect");
					}
					else
					{
						player->SendArena("Specified squad already exists.");
					}
				}

				return true;
			}


			/* Squad owner commands */

			if (MatchString(command, "?squaddissolve", 10))
			{
				// Delete squad
				if (player->player->squad)
				{
					if (player->player->squad->Owner == player->player)
					{
						DATABASE.DeleteSquad(player->player->squad);

						player->SendArena("Squad dissolved. Exit zone for it to take effect.");
					}
					else
					{
						player->SendArena("You are not squad owner.");
					}
				}
				else
				{
					player->SendArena("You are not on a squad.");
				}

				return true;
			}

			if (MatchString(command, "?squadpassword", 14))
			{
				if (length <= 15)
				{
					player->SendArena("This command requires parameters. Type ?man squadpassword for details");
					return true;
				}

				// Change squad password
				if (player->player->squad)
				{
					if (player->player->squad->Owner == player->player)
					{
						player->player->squad->SetPassword(&command[15]);

						player->SendArena("Squad password changed.");
					}
					else
					{
						player->SendArena("You are not squad owner.");
					}
				}
				else
				{
					player->SendArena("You are not on a squad.");
				}

				return true;
			}

			if (MatchString(command, "?squadname", 10))
			{
				if (length <= 11)
				{
					player->SendArena("This command requires parameters. Type ?man squadname for details");
					return true;
				}

				// Change squad name
				if (player->player->squad)
				{
					if (player->player->squad->Owner == player->player)
					{
						strcpy((char*)&player->player->squad->Name[0], &command[11]);

						player->SendArena("Squad name changed. Exit zone for it to take effect");
					}
					else
					{
						player->SendArena("You are not squad owner.");
					}
				}
				else
				{
					player->SendArena("You are not on a squad.");
				}

				return true;
			}

			if (MatchString(command, "?squadkick", 10))
			{
				if (length <= 11)
				{
					player->SendArena("This command requires parameters. Type ?man squadkick for details");
					return true;
				}

				// Delete squaddie
				if (player->player->squad)
				{
					if (player->player->squad->Owner == player->player)
					{
						_listnode <User> * parse = player->player->squad->FindUser(&command[11]);

						if (parse)
						{
							User * user = parse->item;
							player->player->squad->Participants.Delete(parse, true);
							user->squad = NULL;

							player->SendArena("Player removed from squad.");
						}
						else
						{
							player->SendArena("Player is not a squad member.");
						}
					}
					else
					{
						player->SendArena("You are not squad owner.");
					}
				}
				else
				{
					player->SendArena("You are not on a squad.");
				}

				return true;
			}

			if (MatchString(command, "?squadlist", 8))
			{
				// List squaddies
				if (player->player->squad)
				{
//					if (player->player->squad->Owner == player->player)		No longer a squad owner command
					{
						char buffer[512];
						int count = 0;
						strcpy(buffer, "Squadmates: ");

						_listnode <User> * parse = player->player->squad->Participants.head;

						while (parse)
						{
							strcat(buffer, (char*)&parse->item->Name[0]);

							count++;

							if (parse->next)
							{
								strcat(buffer, ",");

								if (count == 10)
								{
									player->SendArena(buffer);

									buffer[0]	= 0;
									count		= 0;
								}
							}

							parse = parse->next;
						}

						if (count)
							player->SendArena(buffer);
					}
/*					else
					{
						player->SendArena("You are not squad owner.");
					}
*/				}
				else
				{
					player->SendArena("You are not on a squad.");
				}

				return true;
			}

			if (MatchString(command, "?squadgrant", 11))
			{
				// Grant owner access to an other player
				if (player->player->squad)
				{
					if (player->player->squad->Owner == player->player)
					{
						_listnode <User> * parse = DATABASE.FindUser((BYTE*)&command[12]);

						if (parse)
						{
							player->player->squad->Owner = parse->item;

							player->SendArena("Squad owner changed.");
						}
						else
						{
							player->SendArena("Unable to find user specified.");
						}
					}
					else
					{
						player->SendArena("You are not squad owner.");
					}

				}
				else
				{
					player->SendArena("You are not on a squad.");
				}

				return true;
			}

			/* More player-squad commands */

			if (MatchString(command, "?squad", 6))
			{
				if (length <= 8)
				{
					if (player->player->squad)
					{
						_string s;
						s  = (char*)&player->player->Name[0];
						s += "'s squad is ";
						s += (char*)&player->player->squad->Name[0];

						player->SendArena(s.Text);
					}
					else
					{
						player->SendArena("You have no squad");
					}

					return true;
				}

				// Check player squad
				_listnode <User> * parse = DATABASE.FindUser((BYTE*)&command[7]);

				if (parse)
				{
					char buffer[512];
					strcpy(buffer, (char*)&parse->item->Name[0]);

					Squad * squad = parse->item->squad;

					if (squad)
					{
						strcat(buffer, "'s squad is ");
						strcat(buffer, (char*)&squad->Name[0]);
					}
					else
					{
						strcat(buffer, " has no squad.");
					}

					player->SendArena(buffer);
				}
				else
				{
					player->SendArena("Specified player does not exist.");
				}

				return true;
			}

			/* BillerOp commands */

			if (MatchString(command, "?login", 6))
			{
				if (length <= 7)
				{
					player->SendArena("SYNTAX: ?login <password>");

					return true;
				}

				if (player->OpStatus == NULL)
				{
					player->OpStatus = DATABASE.ValidateSysopPassword(player, (BYTE*)&command[7]);

					if (player->OpStatus)
					{
						_string s;

						player->OpStatus->AddLogin();

						if (player->OpStatus->GroupID == 0)
							s  = "Successfully logged on as Network-wide level ";
						else
						{
							if (player->OpStatus->ScoreID == 0)
								s  = "Successfully logged on as Group-wide level ";
							else
								s  = "Successfully logged on as Operator level ";
						}
						s += (int) player->OpStatus->Level;

						player->SendArena(s.Text);
					}
				}
				else
					player->SendArena("Already logged on as an Operator. Use ?dop to lift Operator status");

				return true;
			}

			if (MatchString(command, "?deop", 5) || (MatchString(command, "?dop", 4)))
			{
				if (player->OpStatus)
				{
					player->OpStatus->RemoveLogin();

					player->OpStatus = NULL;
					player->SendArena("Operator status lifted.");
				}

				return true;
			}

			if (MatchString(command, "?whois", 6))
			{
				Operator * op = NULL;

				if (length >= 8)
				{
					_listnode <Host> * parse = (Packet->Source->Socket)->HostList.head;

					while (parse)
					{
						// Find user
						_listnode <LUserNode> * user = parse->item->Find(&command[7], true);

						if (user && !user->item->Ghost)
						{
							op = user->item->OpStatus;

							break;
						}

						// Try next zone
						parse = parse->next;
					}

				}
				else
				{
					op = player->OpStatus;
				}

				_string s;

				if (op)
				{
					s = "Logged on as ";

					if (op->GroupID)
					{
						if (op->ScoreID == 0)
						{
							s += "group-wide ";
						}
					}
					else
					{
						s += "network-wide ";
					}

					s += "operator level ";

					switch (op->Level)
					{
					case 0:		s += "0 - Network Administrator";
						break;
					case 1:		s += "1 - Group Manager";
						break;
					case 2:		s += "2 - SysOp";
						break;
					case 3:		s += "3 - Super Moderator";
						break;
					case 4:		s += "4 - Moderator";
						break;
					};
				}
				else
				{
					s = "User not logged in.";
				}

				player->SendArena(s.Text);

				return true;
			}

		if (player->OpStatus)
		{
			switch (player->OpStatus->Level)
			{
			case 0:		///////  Level 0 Operators - Network Administrators  ///////
				if (MatchString(command, "?block", 6))
				{	// ?block <name>
					User * user;

					if (length <= 7)
					{
						user = player->player;
					}
					else
					{
						_listnode <User> * parse = DATABASE.FindUser((BYTE*)&command[7]);
						if (parse)
							user = parse->item;
						else
							user = NULL;
					}

					if (user)
					{
						switch (user->PassBlock)
						{
						case BLOCK_OK:
							player->SendArena("PassBlock: Banfree");
							user->PassBlock = BLOCK_PASS;
							break;
						default:
							player->SendArena("PassBlock: Normal");
							user->PassBlock = BLOCK_OK;
							break;
						};
					}
					else
					{
						player->SendArena("Specified user was not found in the database.");
					}

					return true;
				}

				if (MatchString(command, "?write", 5))
				{
					player->SendArena("Please wait...");
					DATABASE.SaveToDisk();
					player->SendArena("Database stored to disk.");

					return true;
				}

				if (MatchString(command, "?networkreset", 9))
				{
					player->SendArena("Recycling network for the score reset.");

					// Erase the scores
					DATABASE.ScoreDatabase.Clear(false);

					// Traverse the host list
					_listnode <Host> * parse = Packet->Source->Socket->HostList.head;

					while (parse)
					{
						Host * host = parse->item;
						parse = parse->next;

						// Erase references to the scores
						host->ScoreDatabase.Clear(true);

						_listnode <LUserNode> * uparse = host->UserList.head;

						while (uparse)
						{
							uparse->item->score = NULL;
							uparse = uparse->next;
						}

						// Recycle the host
						host->AcceptScores = false;
						host->Recycle();
					}
				}

				if (MatchString(command, "?read", 5))
				{
					player->SendArena("Please wait...");
					DATABASE.LoadSettings();
					player->SendArena("Settings loaded from disk.");

					return true;
				}

				if (MatchString(command, "?version", 4))
				{
					player->SendArena("Subbill pre-release. Build 8");
					player->SendArena("Core provided by Catid. With thanks to Coconut Emulator & Testtube");

					return true;
				}

				if (MatchString(command, "?changepassword", 15))
				{	// ?changepassword Name:Password
					if (length <= 16)
					{
						player->SendArena("This command requires parameters. Type ?man changepassword for details");
						return true;
					}

					BYTE Name[32];
					BYTE Password[32];
					memset(Name, 0, 32);
					memset(Password, 0, 32);

					// Parse input
					SHORT	LeftLength;
					char  * RightText;

					if (ColonParse(&command[16], length - 16, LeftLength, RightText))
					{
						// Find user
						memcpy(Name, &command[16], LeftLength);

						_listnode <User> * user = DATABASE.FindUser(Name);

						if (user)
						{
							if (player->OpStatus->Level)
							{
								_listnode <Operator> * parse = DATABASE.OpDatabase.head;

								while (parse)
								{
									if (parse->item->Level <= player->OpStatus->Level)
									{
										player->SendArena("You may not change player passwords of equal or lower operator status.");

										return true;
									}

									parse = parse->next;
								}
							}

							memcpy(Password, RightText, length - LeftLength - 17);

							HashPassword(Password);

							memcpy(user->item->Password, Password, 32);

							player->SendArena("User information updated.");
						}
						else
						{
							player->SendArena("User not found.");
						}
					}

					return true;
				}

				if (MatchString(command, "?changesquad", 12))
				{	// ?changesquad Squad:Name
					if (length <= 13)
					{
						player->SendArena("This command requires parameters. Type ?man changesquad for details");
						return true;
					}

					BYTE squadname[32];
					BYTE name[32];
					memset(squadname, 0, 32);
					memset(name, 0, 32);

					// Parse input
					SHORT	LeftLength;
					char  * RightText;

					if (ColonParse(&command[13], length - 13, LeftLength, RightText))
					{
						// Find user
						memcpy(squadname, &command[13], LeftLength);

						Squad * squad = DATABASE.FindSquad(squadname);

						if (squad)
						{
							memcpy(name, RightText, length - LeftLength - 14);

							_listnode <User> * user = DATABASE.FindUser(name);

							if (user)
							{
								squad->Owner = user->item;

								player->SendArena("Squad owner changed.");
							}
							else
							{
								player->SendArena("User not found.");
							}
						}
						else
						{
							player->SendArena("Squad not found.");
						}
					}

					return true;
				}

				if (MatchString(command, "?changename", 11))
				{	// ?changename Name:New Name
					if (length <= 12)
					{
						player->SendArena("This command requires parameters. Type ?man changename for details");
						return true;
					}

					BYTE Name[32];
					BYTE NewName[32];
					memset(Name, 0, 32);
					memset(NewName, 0, 32);

					// Parse input
					SHORT	LeftLength;
					char  * RightText;

					if (ColonParse(&command[12], length - 12, LeftLength, RightText))
					{
						// Find user
						memcpy(Name, &command[12], LeftLength);
						memcpy(NewName, RightText, length - LeftLength - 13);

						_listnode <User> * user;
						user = DATABASE.FindUser(NewName);

						if (user == NULL)
						{
							user = DATABASE.FindUser(Name);

							if (user)
							{
								if (player->OpStatus->Level)
								{
									_listnode <Operator> * parse = DATABASE.OpDatabase.head;

									while (parse)
									{
										if (parse->item->Level <= player->OpStatus->Level)
										{
											player->SendArena("You may not change player names of equal or lower operator status.");

											return true;
										}

										parse = parse->next;
									}
								}

								memcpy(user->item->Name, NewName, 32);

								player->SendArena("User information updated.");
							}
							else
							{
								player->SendArena("User not found.");
							}
						}
						else
						{
							player->SendArena("User already exists.");
						}
					}

					return true;
				}

			case 1:		///////  Level 1 Operators - Group Managers  ///////
				if (MatchString(command, "?groupreset", 11))
				{
					LONG GroupID = player->OpStatus->GroupID;
					if (GroupID == 0)
						GroupID = player->zone->GroupID;

					player->SendArena("Recycling zones within your group for the score reset.");

					// Traverse the host list
					_listnode <Host> * parse = Packet->Source->Socket->HostList.head;

					while (parse)
					{
						Host * host = parse->item;
						parse = parse->next;

						if (host->GroupID == GroupID)
						{
							// Erose global score entries
							_listnode <Score> * sparse = host->ScoreDatabase.head;

							while (sparse)
							{
								DATABASE.ScoreDatabase.Delete(sparse->item, false);

								sparse = sparse->next;
							}

							// Erase references to the scores
							host->ScoreDatabase.Clear(true);

							_listnode <LUserNode> * uparse = host->UserList.head;

							while (uparse)
							{
								uparse->item->score = NULL;
								uparse = uparse->next;
							}

							// Recycle the host
							host->AcceptScores = false;
							host->Recycle();
						}
					}
				}

				if (MatchString(command, "?removezone", 11))
				{	// Unregister zone
					if (length > 12)
					{
						char Number[8];
						int Index;

						memset(Number, 0, 8);
						memcpy(Number, &command[12], TrimInt(length - 12, 7));
						Index = atoi(Number);

						_listnode <Zone> * parse = DATABASE.FindZone(Index);

						if (parse && ((player->OpStatus->GroupID == 0) || (player->OpStatus->GroupID == parse->item->GroupID)) )
						{
							DATABASE.ZoneDatabase.Delete(parse, false);

							player->SendArena("Zone unregistered. Recycle zone for it to take effect");
						}
						else
						{
							player->SendArena("Specified zone slot is empty.");
						}
					}

					return true;
				}

				if (MatchString(command, "?addzone", 8))
				{	// Register a zone
					if (length > 9)
					{
						if (player->OpStatus->GroupID)
						{
							_listnode <Zone> * parse = DATABASE.ZoneDatabase.head;
							int Counter = 0;

							while (parse)
							{
								if (parse->item->GroupID == player->OpStatus->GroupID)
									Counter++;

								parse = parse->next;
							}

							if (Counter >= 10)
							{
								player->SendArena("You have exceeded your zone quota of 10 slots.");

								return true;
							}
						}

						char Number[8];		// Zone number (ASCII buffer)
						int Offset,			// Offset to password
							Index;			// Zone number (Decimal form)

						memset(Number, 0, 8);
						for (Offset = 9; Offset < length; Offset++)
						{
							if (command[Offset] == ':')
							{
								memcpy(Number, &command[9], TrimInt(Offset - 9, 7));

								break;
							}
						}
						Index = atoi(Number);
						Offset++;

						if ((Offset > length) || (Index <= 0))
						{
							player->SendArena("Oops. Format: ?addzone <Score ID>:<Password>");
							return true;
						}

						_listnode <Zone> * parse = DATABASE.FindZone(Index);

						if (parse)
						{
							player->SendArena("Specified zone slot is already taken.");
						}
						else
						{
							if ((player->OpStatus->GroupID == 0) || (player->OpStatus->ScoreID != 0))
							{
								player->SendArena("You require group-wide acess to use this command.");

								return true;
							}

							char Password[32];
							memset(Password, 0, 32);
							memcpy(Password, &command[Offset], TrimInt(length - Offset, 31));
							HashPassword((BYTE*)&Password[0]);

							char BanText[128];
							memset(BanText, 0, 128);
							DATABASE.ZoneDatabase.Append(new Zone(player->OpStatus->GroupID, Index, Password, BanText));

							player->SendArena("Zone registered.");
						}
					}
					else
					{
						player->SendArena("This command requires parameters. Type ?man addzone for details");
					}

					return true;
				}

				if (MatchString(command, "?changezone", 11))
				{	// Change zone password ?changezone #:pw
					if (length <= 12)
					{
						player->SendArena("This command requires parameters. Type ?man changezone for details");
						return true;
					}

					char Number[8];		// Zone number (ASCII buffer)
					int Offset,			// Offset to password
						Index;			// Zone number (Decimal form)

					memset(Number, 0, 8);
					for (Offset = 12; Offset < length; Offset++)
					{
						if (command[Offset] == ':')
						{
							memcpy(Number, &command[12], TrimInt(Offset - 12, 7));

							break;
						}
					}
					Index = atoi(Number);
					Offset++;

					if (Offset > length)
					{
						player->SendArena("Oops. Format: ?changezone <Score ID>:<Password>");
						return true;
					}

					_listnode <Zone> * parse = DATABASE.FindZone(Index);

					if (parse && ((player->OpStatus->GroupID == 0) || (player->OpStatus->GroupID == parse->item->GroupID)) )
					{	// Validate operator privelages
						char Password[32];

						memset(Password, 0, 32);
						memcpy(Password, &command[Offset], TrimInt(length - Offset, 31));

						HashPassword((BYTE*)&Password[0]);

						memcpy(parse->item->Password, Password, 32);

						player->SendArena("Zone password changed.");
					}
					else
					{
						player->SendArena("Specified zone slot is empty.");
					}

					return true;
				}

				if (MatchString(command, "?listzone", 9))
				{	// List all zones
					_listnode <Zone> * zone_parse;
					_listnode <Host> * host_parse;
					Host * host;
					Zone * zone;
					bool Found = false;
					_string s;

					zone_parse = DATABASE.ZoneDatabase.head;
					while (zone_parse)
					{
						zone = zone_parse->item;

						if ((player->OpStatus->GroupID == 0) || (player->OpStatus->GroupID == zone->GroupID))
						{
							Found = true;
							s = zone->ScoreID;

							host = Packet->Source->Socket->FindHost(zone->ScoreID);

							if (host)
							{
								if (zone->GroupID != host->GroupID)
								{
									s += " - {Invalid GroupID (";
									s += zone->GroupID;
									s += ")(";
									s += host->GroupID;
									s += ")} Online: ";
								}
								else
								{
									s += " - {";
									s += host->GroupID;
									s += "} Online: ";
								}
								s += (char*)&host->Name[0];
								s += "(";
								s += host->UserList.Total;
								s += ")";
							}
							else
								s += " - Offline.";

							player->SendArena(s.Text);
						}

						zone_parse = zone_parse->next;
					}

					host_parse = Packet->Source->Socket->HostList.head;
					while (host_parse)
					{
						host = host_parse->item;

						if ((player->OpStatus->GroupID == 0) || (player->OpStatus->GroupID == host->GroupID))
						{
							if (host->ScoreID != -1)
							{
								if (DATABASE.FindZone(host->ScoreID) == NULL)
								{
									Found = true;

									s  = "";
									s += host->ScoreID;
									s += " - {";
									s += host->GroupID;
									s += "} Online(Unregistered): ";
									s += (char*)&host->Name[0];
									s += "(";
									s += host->UserList.Total;
									s += ")";

									player->SendArena(s.Text);
								}
							}
							else
							{
								Found = true;

								LONG IP		= (*(sockaddr_in*)&host->Remote).sin_addr.S_un.S_addr;
								LONG Port	= htons((*(sockaddr_in*)&host->Remote).sin_port);

								s  = "Connecting: ";
								s += (int)(((unsigned char*)&IP)[0]);
								s += ".";
								s += (int)(((unsigned char*)&IP)[1]);
								s += ".";
								s += (int)(((unsigned char*)&IP)[2]);
								s += ".";
								s += (int)(((unsigned char*)&IP)[3]);
								s += " : ";
								s += (int) Port;

								player->SendArena(s.Text);
							}
						}

						host_parse = host_parse->next;
					}

					if (!Found)
						player->SendArena("No zones.");

					return true;
				}

				if (MatchString(command, "?closezone", 10))
				{	// Terminate zone (if possible)
					Host * host;

					if (length > 11)
					{
						char Number[8];
						int Index;

						memset(Number, 0, 8);
						memcpy(Number, &command[11], TrimInt(length - 11, 7));
						Index = atoi(Number);

						host = Packet->Source->Socket->FindHost(Index);
					}
					else
					{
						host = player->zone;
					}

					if (host && ((player->OpStatus->GroupID == 0) || (player->OpStatus->GroupID == host->GroupID)) )
					{	// Validate operator privelages
						player->SendArena("Shutdown in progress.");

						host->Shutdown();
					}
					else
					{
						player->SendArena("Specified zone slot is empty.");
					}

					return true;
				}

				if (MatchString(command, "?recyclezone", 12))
				{	// Recycle zone (if possible)
					Host * host;

					if (length > 13)
					{
						char Number[8];
						int Index;

						memset(Number, 0, 8);
						memcpy(Number, &command[13], TrimInt(length - 13, 7));
						Index = atoi(Number);

						host = Packet->Source->Socket->FindHost(Index);
					}
					else
					{
						host = player->zone;
					}

					if (host && ((player->OpStatus->GroupID == 0) || (player->OpStatus->GroupID == host->GroupID)) )
					{	// Validate operator privelages
						player->SendArena("Recycle in progress.");

						host->Recycle();
					}
					else
					{
						player->SendArena("Specified zone slot is empty.");
					}

					return true;
				}

			case 2:		///////  Level 2 Operators - SysOps  ///////
				if (MatchString(command, "?groupid", 8))
				{
					_string s;
					s = "GroupId:";
					s += player->zone->GroupID;

					if (player->OpStatus->GroupID == 0)
					{
						player->SendArena(s.Text);
					}
					else if ((player->OpStatus->ScoreID == 0) && (player->OpStatus->GroupID == player->zone->GroupID))
					{
						player->SendArena(s.Text);
					}
					else if (player->OpStatus->ScoreID == player->zone->ScoreID)
					{
						player->SendArena(s.Text);
					}
					else
					{
						player->SendArena("You do not have access here.");
					}

					return true;
				}

				if (MatchString(command, "?scoreid", 8))
				{
					_string s;
					s = "ScoreId:";
					s += player->zone->ScoreID;

					if (player->OpStatus->GroupID == 0)
					{
						player->SendArena(s.Text);
					}
					else if ((player->OpStatus->ScoreID == 0) && (player->OpStatus->GroupID == player->zone->GroupID))
					{
						player->SendArena(s.Text);
					}
					else if (player->OpStatus->ScoreID == player->zone->ScoreID)
					{
						player->SendArena(s.Text);
					}
					else
					{
						player->SendArena("You do not have access here.");
					}

					return true;
				}

				if (MatchString(command, "?notifyzone", 8))
				{
					// Check if there is a request for a certain state.
					if (length >= 13)
					{
						switch (command[12])
						{
						case 'o':
						case 'O':
							if (length >= 14)
							{
								if (player->ZoneNotify = (command[13] != 'f') && (command[13] != 'F'))
									player->SendArena("Zone notify ENABLED");
								else
									player->SendArena("Zone notify DISABLED");

								return true;
							}
						case 'y':
						case 'Y':
						case 't':
						case 'T':
						case 1:
							{
								player->SendArena("Zone notify ENABLED");
								player->ZoneNotify = true;
								if (player->player->regform)
									player->player->regform->NotifyZone = 1;
							}
							return true;
						case 'n':
						case 'N':
						case 'f':
						case 'F':
						case 0:
							{
								player->SendArena("Zone notify DISABLED");
								player->ZoneNotify = false;
								if (player->player->regform)
									player->player->regform->NotifyZone = 0;
							}
							return true;
						};
					}

					// Otherwise just toggle it.
					if (player->ZoneNotify = !player->ZoneNotify)
					{
						player->SendArena("Zone notify ENABLED");
						if (player->player->regform)
							player->player->regform->NotifyZone = 1;
					}
					else
					{
						player->SendArena("Zone notify DISABLED");
						if (player->player->regform)
							player->player->regform->NotifyZone = 0;
					}

					return true;
				}

				if (MatchString(command, "?extchat", 8))
				{
					// Check if there is a request for a certain state.
					if (length >= 10)
					{
						switch (command[9])
						{
						case 'o':
						case 'O':
							if (length >= 11)
							{
								if ((command[10] != 'f') && (command[10] != 'F'))
								{
									player->SendArena("External chat ENABLED");
									Packet->Source->BroadcastChat = true;
								}
								else
								{
									player->SendArena("External chat DISABLED");
									Packet->Source->BroadcastChat = false;
								}

								return true;
							}
						case 'y':
						case 'Y':
						case 't':
						case 'T':
						case '1':
							{
								player->SendArena("External chat ENABLED");
								Packet->Source->BroadcastChat = true;
							}
							return true;
						case 'n':
						case 'N':
						case 'f':
						case 'F':
						case '0':
							{
								player->SendArena("External chat DISABLED");
								Packet->Source->BroadcastChat = false;
							}
							return true;
						};
					}

					// Toggle if there is no preference.
					if (Packet->Source->BroadcastChat = !Packet->Source->BroadcastChat)
					{
						player->SendArena("External chat ENABLED");
					}
					else
					{
						player->SendArena("External chat DISABLED");
					}

					return true;
				}

				if (MatchString(command, "?bantext", 8))
				{
					_listnode <Zone> * zparse = DATABASE.ZoneDatabase.head;
					Zone * zone = NULL;

					while (zparse)
					{
						if (zparse->item->ScoreID == Packet->Source->ScoreID)
						{
							zone = zparse->item;

							break;
						}

						zparse = zparse->next;
					}

					if (zone)
					{
						if (length >= 9)
						{
							char Comment[128];

							memset(Comment, 0, 128);
							memcpy(Comment, &command[9], TrimInt(length - 9, 127));
							memcpy(zone->BanText, Comment, 128);

							player->SendArena("Ban text changed.");
						}
						else
						{
							_string s;
							s = "Ban text: ";
							s += zone->BanText;
							player->SendArena(s.Text);
						}
					}
					else
					{
						player->SendArena("This zone is not registered. Only registered zones may have ban text");
					}

					return true;
				}

			case 3:		///////  Level 3 Operators - Super Moderators  ///////
				if (MatchString(command, "?addop", 6))
				{
					if (length > 7)
					{
						// Uses the current zone as a reference point
						// ?addop -g* -0 name:pw	Network Administrators
						// ?addop -g* -1 name:pw	Hosts
						// ?addop -g* -2 name:pw	SysOps
						// ?addop -g* -3 name:pw	Super Moderators
						// ?addop -g* -4 name:pw	Moderators
						// -g = group-wide (default = zone-wide)
						// -g=GroupID = new group-wide (default = zone-wide)
						// -* = network-wide (default = use -g switch settings)
						// -# = operator level (default = 4)

						SHORT Offset;
						LONG GroupID = 0;
						bool NetworkWide = false,
							 GroupWide = false;
						BYTE Level = 4;
						char GroupString[8];
						int Index;

						for (Offset = 7; Offset < length; Offset++)
						{
							if (command[Offset] == '-')
							{
								Offset++;

								if (Offset > length)
								{
									player->SendArena("Invalid switch.");

									return true;
								}

								do
								{
									switch (command[Offset])
									{
									case '*':
										NetworkWide = true;

										break;
									case 'g':	// -g			(use current group id)
									case 'G':	// -g=Number	(specify a group id)
										Offset++;

										if ((Offset + 1) > length)
										{
											player->SendArena("Invalid switch.");

											return true;
										}

										if (command[Offset] == '=')
										{
											Offset++;
											Index = 0;
											memset(GroupString, 0, 8);

											while (Offset < length)
											{
												if ((command[Offset] < 48) || (command[Offset] > 57))
												{
													GroupID = atoi(GroupString);

													Offset--;

													break;
												}
												else
												{
													GroupString[Index++] = command[Offset];

													if (Index >= 8)
													{
														player->SendArena("Invalid switch.");

														return true;
													}
												}

												Offset++;
											};
										}
										else
										{
											Offset--;
										}

										GroupWide = true;

										break;
									case '0':
										Level = 0;

										break;
									case '1':
										Level = 1;

										break;
									case '2':
										Level = 2;

										break;
									case '3':
										Level = 3;

										break;
									case '4':
										Level = 4;

										break;
									default:
										player->SendArena("Invalid switch.");

										return true;
									};

									Offset++;

									if (Offset > length)
									{
										player->SendArena("Invalid switch.");

										return true;
									}
								} while (command[Offset] != ' ');
							}
							else if (command[Offset] != ' ')
								break;
						}

						if (Offset == length)
						{
							player->SendArena("This command requires parameters. Type ?man addop for details");

							return true;
						}

						bool Allow = false;

						if ((NetworkWide == false) && (GroupID == 0))
							GroupID = Packet->Source->GroupID;

						// Check if op is in the same sector of the biller
						if (player->OpStatus->GroupID == 0)
							Allow = true;
						else if (player->OpStatus->GroupID == GroupID)
						{
							if (player->OpStatus->ScoreID == 0)
								Allow = true;
							else if ((GroupWide == false) && (player->OpStatus->ScoreID == player->zone->ScoreID))
								Allow = true;
						}

						if (Allow == false)
						{
							player->SendArena("You do not have authority to register administrators outside your sector.");

							return true;
						}

						// Check if op has a restricted access level
						switch (player->OpStatus->Level)
						{
						case 1:	if (Level < 1) Allow = false;
							break;
						case 2:	if (Level < 2) Allow = false;
							break;
						case 3:	if (Level < 4) Allow = false;
							break;
						case 4:	Allow = false;
							break;
						};

						if (Allow == false)
						{
							player->SendArena("You do not have authority to register administrators below your level.");

							return true;
						}

						BYTE Name[32];
						BYTE Password[32];
						memset(Name, 0, 32);
						memset(Password, 0, 32);

						// Parse input
						SHORT	LeftLength;
						char  * RightText;

						if (ColonParse(&command[Offset], length, LeftLength, RightText))
						{
							memcpy(Name, &command[Offset], LeftLength);
							memcpy(Password, RightText, length - LeftLength);

							_listnode <User> * parse = DATABASE.FindUser(Name);

							if (parse)
							{
								HashPassword(Password);

								_string s;
								s  = (char*)Name;
								s += ": Operator level ";
								s += Level;
								if (NetworkWide)
								{
									s += " added network-wide.";

									DATABASE.OpDatabase.Append(new Operator(parse->item, 0, 0, Level, (char*)&Password[0]));
								}
								else
								{
									if (GroupWide)
									{
										s += " added group-wide.";

										DATABASE.OpDatabase.Append(new Operator(parse->item, GroupID, 0, Level, (char*)&Password[0]));
									}
									else
									{
										s += " added zone-wide.";

										DATABASE.OpDatabase.Append(new Operator(parse->item, GroupID, Packet->Source->ScoreID, Level, (char*)&Password[0]));
									}
								}

								player->SendArena(s.Text);
							}
							else
							{
								player->SendArena("Specified player not found.");
							}
						}
						else
						{
							player->SendArena("Invalid parameters. Type ?man addop for details");
						}
					}
					else
					{
						player->SendArena("This command requires parameters. Type ?man addop for details");
					}

					return true;
				}

				if (MatchString(command, "?removeop", 9))
				{	// Unregister operator
					if (length > 10)
					{
						char Number[8];
						int Index;

						memset(Number, 0, 8);
						memcpy(Number, &command[10], TrimInt(length - 10, 7));
						Index = atoi(Number);

						_listnode <Operator> * op_parse = DATABASE.FindOp(player->OpStatus, Index);

						if (op_parse)
						{
							Operator * op = op_parse->item;

							if (op != player->OpStatus)
							{
								bool Allow = true;

								// Check if op has a restricted access level
								switch (player->OpStatus->Level)
								{
									case 1:	if (op->Level <= 1)	Allow = false;
										break;
									case 2:	if (op->Level <= 2)	Allow = false;
										break;
									case 3:	if (op->Level <= 3)	Allow = false;
										break;
									case 4:	Allow = false;
										break;
								};

								// Send line if access is disallowed.
								if (Allow == false)
								{
									player->SendArena("You do not have authority to remove administrators at or below your level.");

									return true;
								}
							}

							// Erase operator sessions with everyone online
							_listnode <Host> * parse = Packet->Source->Socket->HostList.head;

							while (parse)
							{
								Host * host = parse->item;

								_listnode <LUserNode> * parse_user = host->UserList.head;

								while (parse_user)
								{
									LUserNode * user = parse_user->item;

									if (user->OpStatus == op)
										user->OpStatus = NULL;

									parse_user = parse_user->next;
								}

								parse = parse->next;
							}

							// Delete the operator
							DATABASE.OpDatabase.Delete(op_parse, false);

							player->SendArena("Operator unregistered. All active sessions with this operator are closed");
						}
						else
						{
							player->SendArena("Specified operator slot is empty.");
						}
					}
					else
					{
						player->SendArena("This command requires parameters. Type ?man removeop for details");
					}

					return true;
				}

				if (MatchString(command, "?changeop", 9))
				{	// Change operator password ?changeop #:pw
					if (length <= 10)
					{
						player->SendArena("This command requires parameters. Type ?man changeop for details");
						return true;
					}

					char Number[8];		// Op number (ASCII buffer)
					int Offset,			// Offset to password
						Index;			// Op number (Decimal form)

					memset(Number, 0, 8);
					for (Offset = 10; Offset < length; Offset++)
					{
						if (command[Offset] == ':')
						{
							memcpy(Number, &command[10], TrimInt(Offset - 10, 7));

							break;
						}
					}

					Index = atoi(Number);
					Offset++;

					if (Offset > length)
					{
						char Password[32];

						memset(Password, 0, 32);
						memcpy(Password, &command[10], TrimInt(length - 10, 31));

						HashPassword((BYTE*)&Password[0]);

						memcpy(player->OpStatus->Password, Password, 32);

						player->SendArena("Your operator password is changed.");

						return true;
					}

					_listnode <Operator> * parse = DATABASE.FindOp(player->OpStatus, Index);

					if (parse)
					{
						Operator * op = parse->item;
						bool Allow = true;

						if (op != player->OpStatus)
						{
							// Check if op has a restricted access level
							if ((player->OpStatus->Level != 0) && (op->Level <= player->OpStatus->Level))
								Allow = false;

							// Send line if access is disallowed.
							if (Allow == false)
							{
								player->SendArena("You do not have authority to change administrators' passwords at or below your level.");

								return true;
							}
						}

						char Password[32];

						memset(Password, 0, 32);
						memcpy(Password, &command[Offset], TrimInt(length - Offset, 31));

						HashPassword((BYTE*)&Password[0]);

						memcpy(parse->item->Password, Password, 32);

						player->SendArena("Operator password changed.");
					}
					else
					{
						player->SendArena("Specified operator slot is empty.");
					}

					return true;
				}

				if (MatchString(command, "?info", 5))
				{	// ?info <name>
					User * user;

					if (length <= 6)
					{
						user = player->player;
					}
					else
					{
						_listnode <User> * parse = DATABASE.FindUser((BYTE*)&command[6]);
						if (parse)
							user = parse->item;
						else
						{
							user = NULL;

							char number[8];
							memset(number, 0, 8);
							memcpy(number, &command[6], TrimInt(length - 6, 7));
							int index = atoi(number);

							if (index > 0)
							{
								_listnode <User> * uparse = DATABASE.UserDatabase.head;

								while (uparse)
								{
									if (uparse->item->LoadID == index)
									{
										user = uparse->item;

										break;
									}
								}
							}
						}
					}

					if (user)
					{
						_string s;
						tm * CDate;

						s  = (char*)&user->Name[0];
						s += " (#";
						s += user->LoadID;
						s += ") Last known information:";

						player->SendArena(s.Text);

						s  = "Creation: ";
						CDate = Localize(&user->CreationDate, player->player->TimeZoneBias);
						if (CDate)
						{
							s += CDate->tm_mon + 1;
							if (CDate->tm_mday < 10)
								s += "-0";
							else
								s += "-";
							s += CDate->tm_mday;
							s += "-";
							s += GetYear(CDate);
						}
						else
						{
							s += "(Invalid date)";
						}
						s += ", Login: ";
						CDate = Localize(&user->LastLogin, player->player->TimeZoneBias);
						if (CDate)
						{
							s += CDate->tm_mon + 1;
							if (CDate->tm_mday < 10)
								s += "-0";
							else
								s += "-";
							s += CDate->tm_mday;
							s += "-";
							s += GetYear(CDate);
						}
						else
						{
							s += "(Invalid date)";
						}
						s += ", PassBlock: ";
						switch (user->PassBlock)
						{
						case BLOCK_OK:		s += "Normal";
							break;
						default:			s += "Banfree";
							break;
						};
						s += ", TZB: ";
						s += user->TimeZoneBias;

						player->SendArena(s.Text);

						s  = "IP: ";
						s += (int)(((unsigned char*)&user->IP)[0]);
						s += ".";
						s += (int)(((unsigned char*)&user->IP)[1]);
						s += ".";
						s += (int)(((unsigned char*)&user->IP)[2]);
						s += ".";
						s += (int)(((unsigned char*)&user->IP)[3]);
						s += ", MachineID: ";
						s += user->MacID;
						s += ", HardwareID: ";
						if (user->regform)
							s += user->regform->HardwareID;
						else
							s += "(none)";

						player->SendArena(s.Text);
					}
					else
					{
						player->SendArena("Specified user was not found in the database.");
					}

					return true;
				}
			};		///////  Level 4 Operators - Moderators  ///////

				if (MatchString(command, "?banfree", 8))
				{	// ?banfree <name>
					User * user;

					if (length <= 9)
					{
						user = player->player;
					}
					else
					{
						_listnode <User> * parse = DATABASE.FindUser((BYTE*)&command[9]);
						if (parse)
							user = parse->item;
						else
						{
							user = NULL;

							char number[8];
							memset(number, 0, 8);
							memcpy(number, &command[9], TrimInt(length - 6, 7));
							int index = atoi(number);

							if (index > 0)
							{
								_listnode <User> * uparse = DATABASE.UserDatabase.head;

								while (uparse)
								{
									if (uparse->item->LoadID == index)
									{
										user = uparse->item;

										break;
									}

									uparse = uparse->next;
								}
							}
						}
					}

					if (user)
					{
						Banfree * banfree = new Banfree(Packet->Source->GroupID, Packet->Source->ScoreID, user->LoadID);
						banfree->Player = user;
						DATABASE.BanfreeDatabase.Append(banfree);
						Packet->Source->BanfreeDatabase.Append(banfree);

						_string s;
						s  = "Banfree added: UserId #";
						s += user->LoadID;

						player->SendArena(s.Text);
					}
					else
					{
						player->SendArena("Specified user was not found in the database.");
					}

					return true;
				}

				if (MatchString(command, "?listbanfree", 9))
				{	// ?listbanf
					_listnode <Banfree> * parse = Packet->Source->BanfreeDatabase.head;
					int Index = 0;
					bool Found = false;

					while (parse)
					{
						Banfree * banfree = parse->item;

						if (banfree->Player == NULL)
							DATABASE.ComputeBanfree(banfree);

						_string s;
						s  = ++Index;
						s += ") ";
						if (banfree->Player)
						{
							s += (char*)&banfree->Player->Name[0];
						}
						else
						{
							s += "UserId #";
							s += banfree->Owner;
						}

						player->SendArena(s.Text);

						parse = parse->next;
						Found = true;
					}

					if (Found == false)
						player->SendArena("No banfrees.");

					return true;
				}

				if (MatchString(command, "?liftbanfree", 12))
				{	// ?liftbanfree <#>
					if (length > 13)
					{
						// Find ban
						char Number[5];
						int Index, Counter = 0;

						memset(Number, 0, 5);
						memcpy(Number, &command[13], TrimInt(length - 13, 4));
						Index = atoi(Number);

						_listnode <Banfree> * parse = Packet->Source->BanfreeDatabase.head;

						while (parse)
						{
							Counter++;

							if (Counter == Index)
							{
								Packet->Source->BanfreeDatabase.Delete(parse, false);

								player->SendArena("Banfree lifted.");

								return true;
							}

							parse = parse->next;
						}

						player->SendArena("Specified banfree slot is empty.");
					}

					return true;
				}

				if (MatchString(command, "?notifyban", 8))
				{
					// Check if there is a request for a certain state.
					if (length >= 12)
					{
						switch (command[11])
						{
						case 'o':
						case 'O':
							if (length >= 13)
							{
								if (player->BanNotify = (command[13] != 'f') && (command[13] != 'F'))
									player->SendArena("Ban notify ENABLED");
								else
									player->SendArena("Ban notify DISABLED");

								return true;
							}
						case 'y':
						case 'Y':
						case 't':
						case 'T':
						case '1':
							{
								player->SendArena("Ban notify ENABLED");
								player->BanNotify = true;
								if (player->player->regform)
									player->player->regform->NotifyBan = 1;
							}
							return true;
						case 'n':
						case 'N':
						case 'f':
						case 'F':
						case '0':
							{
								player->SendArena("Ban notify DISABLED");
								player->BanNotify = false;
								if (player->player->regform)
									player->player->regform->NotifyBan = 0;
							}
							return true;
						};
					}

					// Toggle if there is no preference.
					if (player->BanNotify = !player->BanNotify)
					{
						player->SendArena("Ban notify ENABLED");
						if (player->player->regform)
							player->player->regform->NotifyBan = 1;
					}
					else
					{
						player->SendArena("Ban notify DISABLED");
						if (player->player->regform)
							player->player->regform->NotifyBan = 0;
					}

					return true;
				}

				if (MatchString(command, "?changeop", 9))
				{	// Change operator password ?changeop pw
					if (length <= 10)
					{
						player->SendArena("This command requires parameters. Type ?man changeop for details");
						return true;
					}

					char Password[32];

					memset(Password, 0, 32);
					memcpy(Password, &command[10], TrimInt(length - 10, 31));
					HashPassword((BYTE*)&Password[0]);
					memcpy(player->OpStatus->Password, Password, 32);

					player->SendArena("Operator password changed.");

					return true;
				}

				if (MatchString(command, "?listban", 8))
				{
					bool Found = false;
					bool ShowDetails = false;
					_listnode <Ban> * parse = Packet->Source->BanDatabase.head;
					_string s;

					if (MatchString(command, "?listban -d", 11))
					{
						ShowDetails = true;
					}

					while (parse)
					{
						Ban * ban = parse->item;

						if ( (ban->GroupID == 0) || 
							 (player->OpStatus->GroupID == 0) ||
							 ((player->OpStatus->ScoreID == 0) && (player->OpStatus->GroupID == ban->GroupID)) ||
							 (player->OpStatus->ScoreID == ban->ScoreID) )
						{
							// Send ban info
							Found = true;

							s = ban->BanID;
							if (ban->GroupID == 0)
								s += "*) ";
							else if (ban->ScoreID == 0)
							{
								s += "$) {";
								s += ban->GroupID;
								s += "} ";
							}
							else
							{
								s += ") <";
								Host * host = Packet->Source->Socket->FindHost(ban->ScoreID);
								if (host)
									s += (char*)&host->Name[0];
								else
									s += ban->ScoreID;
								s += "> ";
							}
							s += ban->Name;

							if (ShowDetails)
							{
								s += " [";
								switch (ban->IPEnd ^ ban->IPStart)
								{
								case 0:
									{
										s += (int)(((unsigned char*)&ban->IPStart)[0]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[1]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[2]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[3]);
									}
									break;
								case 0xFF000000:
									{
										s += (int)(((unsigned char*)&ban->IPStart)[0]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[1]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[2]);
										s += ".*";
									}
									break;
								case 0xFFFF0000:
									{
										s += (int)(((unsigned char*)&ban->IPStart)[0]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[1]);
										s += ".*.*";
									}
									break;
								case 0xFFFFFF00:
									{
										s += (int)(((unsigned char*)&ban->IPStart)[0]);
										s += ".*.*.*";
									}
									break;
								default:
									{
										s += (int)(((unsigned char*)&ban->IPStart)[0]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[1]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[2]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPStart)[3]);
										s += "-";
										s += (int)(((unsigned char*)&ban->IPEnd)[0]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPEnd)[1]);
										s += ".";
										s += (int)(((unsigned char*)&ban->IPEnd)[2]);
											s += ".";
										s += (int)(((unsigned char*)&ban->IPEnd)[3]);
									}
									break;
								};
								s += "] until ";
								tm * CDate = Localize(&ban->Timer, player->player->TimeZoneBias);
								if (CDate)
								{
									s += CDate->tm_mon + 1;
									if (CDate->tm_mday < 10)
										s += "-0";
									else
										s += "-";
									s += CDate->tm_mday;
									s += "-";
									s += GetYear(CDate);
								}
								else
								{
									s += "(Invalid date)";
								}
								s += ". Set ";
								CDate = Localize(&ban->CreationDate, player->player->TimeZoneBias);
								if (CDate)
								{
									s += CDate->tm_mon + 1;
									if (CDate->tm_mday < 10)
										s += "-0";
									else
										s += "-";
									s += CDate->tm_mday;
									s += "-";
									s += GetYear(CDate);
								}
								else
								{
									s += "(Invalid date)";
								}
								s += " by ";
								if (ban->Creator)
									s += (char*)&ban->Creator->Name[0];
								else
									s += "(Unknown)";
								s += ":";
								s += ban->OpLevel;
								if (ban->LastLogin != ban->CreationDate)
								{
									CDate = Localize(&ban->LastLogin, player->player->TimeZoneBias);
									if (CDate)
									{
										s += ". Last access ";
										s += CDate->tm_mon + 1;
										if (CDate->tm_mday < 10)
											s += "-0";
										else
											s += "-";
										s += CDate->tm_mday;
										s += "-";
										s += GetYear(CDate);
										s += " ";
										s += CDate->tm_hour;
										if (CDate->tm_min < 10)
											s += ":0";
										else
											s += ":";
										s += CDate->tm_min;
										if (CDate->tm_sec < 10)
											s += ".0";
										else
											s += ".";
										s += CDate->tm_sec;
									}
									else
									{
										s += ". Last access (Invalid date)";
									}
								}
							}

							player->SendArena(s.Text);

							// Send ban comment
							if (strlen(ban->Comment))
								player->SendArena(ban->Comment);
						}

						parse = parse->next;
					}

					if (!Found)
						player->SendArena("No bans.");

					return true;
				}

				if (MatchString(command, "?commentban", 11))
				{
					if (length <= 12)
					{
						player->SendArena("This command requires parameters. Type ?man commentban for details");
						return true;
					}

					// Find ban
					char Number[5];		// Ban number (ASCII buffer)
					int Offset,			// Offset to comment
						Index;			// Ban number (Decimal form)

					memset(Number, 0, 5);
					for (Offset = 12; Offset < length; Offset++)
					{
						if (command[Offset] == ':')
						{
							memcpy(Number, &command[12], TrimInt(Offset - 12, 4));

							break;
						}
					}
					Index = atoi(Number);
					Offset++;

					if (Offset > length)
					{
						player->SendArena("Oops. Format: ?commentban <Ban ID>:<Comment>");
						return true;
					}

					if ((Index > 0) && (Index <= DATABASE.NextUniversalBanID))
					{
						_listnode <Ban> * parse = Packet->Source->BanDatabase.head;

						while (parse)
						{
							Ban * ban = parse->item;

							if (ban->BanID == Index)
							{
								if ( (player->OpStatus->GroupID == 0) ||
									 ((player->OpStatus->ScoreID == 0) && (player->OpStatus->GroupID == ban->GroupID)) ||
									 (player->OpStatus->ScoreID == ban->ScoreID) ||
									 (player->OpStatus->Level <= ban->OpLevel) )
								{
									// Trigger comment
									char Comment[64];

									memset(Comment, 0, 64);
									memcpy(Comment, &command[Offset], TrimInt(length - Offset, 63));
									memcpy(parse->item->Comment, Comment, 64);

									player->SendArena("Ban comment changed.");
								}
								else
								{
									// Show error
									player->SendArena("You do not have authority to comment this ban.");
								}

								return true;
							}

							parse = parse->next;
						}
					}
					else
					{
						player->SendArena("Specified ban slot is empty.");
					}

					return true;
				}

				if (MatchString(command, "?liftban", 8))
				{
					if (length > 9)
					{
						// Find ban
						char Number[5];
						int Index;

						memset(Number, 0, 5);
						memcpy(Number, &command[9], TrimInt(length - 9, 4));
						Index = atoi(Number);

						if ((Index > 0) && (Index <= DATABASE.NextUniversalBanID))
						{
							_listnode <Ban> * parse = Packet->Source->BanDatabase.head;

							while (parse)
							{
								Ban * ban = parse->item;

								if (ban->BanID == Index)
								{
									if ( ((player->OpStatus->GroupID == 0) ||
										 ((player->OpStatus->ScoreID == 0) && (player->OpStatus->GroupID == ban->GroupID)) ||
										 (player->OpStatus->ScoreID == ban->ScoreID)) &&
										 (player->OpStatus->Level <= ban->OpLevel) )
									{
										// Trigger delete
										Packet->Source->UnbanUser(ban);

										player->SendArena("Ban lifted.");
									}
									else
									{
										// Check for permission
										player->SendArena("You do not have authority to lift this ban.");
									}

									return true;
								}

								parse = parse->next;
							}

							player->SendArena("Specified ban slot is empty.");
						}
						else
						{
							player->SendArena("Specified ban slot is empty.");
						}
					}

					return true;
				}

				if (MatchString(command, "?ban", 4))
				{
					if (length <= 5)
					{
						player->SendArena("This command requires parameters. Type ?man ban for details");
						return true;
					}

					bool Kick = true,		// Kick player after adding ban
						 UseRange = false,	// Use IP range in the ban
						 AutoBlock = false,	// WhoIs hostname to get NetBlock
						 AutoRange = false;	// Automatically do a subnet ban
					LONG RangeStart,		// IPStart
						 RangeEnd,			// IPEnd
						 Offset,			// ParseIP's 5th argument
						 GroupID,			// Network-wide ban
						 ScoreID;			// Group-wide ban
					char Name[32];			// Buffer containing parsed player name
					int	 NameLen = 0;		// Length of name buffer
					BYTE OpLevel;			// Operator access level
					long Days = 1;			// Ban days
					char DayString[8];		// Ban days as a string
					int	 Index;				// Used to parse the ban days string

					/* Set default values */
					GroupID = Packet->Source->GroupID;
					ScoreID = Packet->Source->ScoreID;
					OpLevel = player->OpStatus->Level;

					/* Parse switches */
					int i = 5;
					while (i < length)
					{
						if (command[i] == '-')
						{
							// Switches:
							//  -k (don't kick)
							//  -i 127.0.0.1-255.255.255.255 (ip range)
							//  -i 127.0.0.* (ip subnet)
							//  -i 127.0.0.1 (static ip)
							//  -s (subnet only)
							//  -! (entire IP range)
							//  -* (maximum ban influence)
							//  -d=days (day timer)

							i++;
							switch (command[i])
							{
							case 'K':		// Don't kick the player
							case 'k':
								{
									Kick = false;
								}
								break;
							case 'D':		// Ban timer
							case 'd':
								i++;

								if (i >= length)
								{
									player->SendArena("Invalid switch.");

									return true;
								}

								if (command[i] == '=')
								{
									i++;
									Index = 0;
									memset(DayString, 0, 8);

									while (i < length)
									{
										if ((command[i] < 48) || (command[i] > 57))
										{
											Days = atoi(DayString);

											if (Days <= 0)
												Days = 1;

											if (Days > 5000)
												Days = 5000;

											switch (player->OpStatus->Level)
											{
											case 2: if (Days > 365) Days = 365;	break;
											case 3: if (Days > 60) Days = 60;	break;
											case 4: if (Days > 7) Days = 7;		break;
											};

											i--;

											break;
										}
										else
										{
											DayString[Index++] = command[i];

											if (Index >= 8)
											{
												player->SendArena("Invalid switch.");

												return true;
											}
										}

										i++;
									};
								}
								else
								{
									i--;
								}

								break;
							case 'G':		// Group-wide ban
							case 'g':
								{
									if (player->OpStatus->GroupID == 0)
									{
										ScoreID = 0;
									}
									else if (player->OpStatus->ScoreID == 0)
									{
										ScoreID = 0;
									}
									else
									{
										player->SendArena("-g: You cannot add group-wide bans.");

										return true;
									}
								}
								break;
							case '*':		// Network/Group-wide ban
								{
									if (player->OpStatus->GroupID == 0)
									{
										GroupID = 0;
										ScoreID = 0;
									}
									else if (player->OpStatus->ScoreID == 0)
									{
										ScoreID = 0;
									}
									else
									{
										player->SendArena("-*: You cannot add network-wide bans.");

										return true;
									}
								}
								break;
							case '!':		// Automatic ISP-router ban
								{
									if (player->OpStatus->Level <= 2)
									{
										UseRange = true;
										AutoBlock = true;
									}
									else
									{
										player->SendArena("-!: You cannot ban player ISP's.");

										return true;
									}
								}
								break;
							case 'S':		// Automatic subnet ban
							case 's':
								{
									if (player->OpStatus->Level <= 3)
									{
										UseRange = true;
										AutoRange = true;
									}
									else
									{
										player->SendArena("-s: You cannot add subnet bans.");

										return true;
									}
								}
								break;
							case '0':		// Manual access level
							case '1':
							case '2':
							case '3':
							case '4':
								{
									OpLevel = command[i] - 48;	// ASCII -> Decimal

									if (player->OpStatus->Level > OpLevel)
									{
										player->SendArena("-level: You cannot add bans at the requested access level.");

										return true;
									}
								}
								break;
							case 'I':		// Manual IP Range
							case 'i':
								{
									if (player->OpStatus->Level == 0)
									{
										UseRange = true;

										if (length <= (i + 2))
										{
											player->SendArena("Invalid IP range parameters. Aborted");
											return true;
										}

										if (ParseIP(&command[i + 2], length - (i + 2), RangeStart, RangeEnd, Offset))
										{
											i += Offset + 1;
										}
										else
										{
											player->SendArena("Invalid IP range parameters. Aborted");
											return true;
										}
									}
									else
									{
										player->SendArena("-i: You cannot specify an IP range.");

										return true;
									}
								}
								break;
							};
						}
						else if (command[i] != ' ')
						{
							for (int n = i; n < length; n++)
							{
								Name[NameLen++] = command[n];

								// Name information
								if (NameLen >= 20)
								{
									player->SendArena("Name: Specified name ludicrously long.");

									return true;
								}
							}

							break;
						}

						i++;
					}

					if (player->OpStatus->ScoreID && (player->OpStatus->ScoreID != player->zone->ScoreID))
					{
						player->SendArena("You may not ban outside of your zone.");

						return true;
					}

					if (player->OpStatus->GroupID && (player->OpStatus->GroupID != player->zone->GroupID))
					{
						player->SendArena("You may not ban outside of your group.");

						return true;
					}

					Name[NameLen] = 0;

					/* Parse username */
					User * UserData;

					_listnode <LUserNode> * parse = Packet->Source->Find(Name, true);

					if (parse)
					{
						UserData = parse->item->player;
					}
					else
					{
						_listnode <User> * user = DATABASE.FindUser((BYTE*)&Name[0]);

						if (user)
						{
							UserData = user->item;
						}
						else
						{
							player->SendArena("Unable to find given user in network logs. Aborted");
							player->SendArena(Name);

							return true;
						}
					}

					// Check if this ban can't be made
					_listnode <Operator> * oparse = DATABASE.OpDatabase.head;

					while (oparse)
					{
						if ((oparse->item->Owner == UserData) && (oparse->item->Level <= player->OpStatus->Level))
						{
							player->SendArena("You cannot ban operators at or below your level.");

							return true;
						}

						oparse = oparse->next;
					}

					// Apply switch settings to IP range
					if (UseRange)
					{
						if (AutoRange)
						{
							RangeStart	= UserData->IP & 0x00FFFFFF;
							RangeEnd	= UserData->IP | 0xFF000000;
						}
						else if (AutoBlock)
						{
							player->SendArena("Please wait while downloading information from whois.arin.net...");
							if (!UserData->IP || !GetBlock(UserData->IP, RangeStart, RangeEnd))
							{
								player->SendArena("Unable to calculate NetBlock. Try your request again soon");

								return true;
							}
						}
					}
					else
					{
						RangeStart = RangeEnd = UserData->IP;
					}

					/* Add ban */
					Packet->Source->BanUser(UserData, GroupID, ScoreID, OpLevel, "", RangeStart, RangeEnd, UserData->MacID, (UserData->regform ? UserData->regform->HardwareID : 0), Days, player->player);

					// Kick the player if directed
					if (parse && Kick) parse->item->Kick(0, DATABASE.NextUniversalBanID, DATABASE.NextUniversalBanID);

					_string s;
					s  = "Ban #";
					s += DATABASE.NextUniversalBanID;

					if (GroupID == 0)
						s += " added network-wide.";
					else if (ScoreID == 0)
						s += " added group-wide.";
					else
						s += " added.";

					player->SendArena(s.Text);

					return true;
				}

				if (MatchString(command, "?alias", 6))
				{
					_listnode <User> * parse;

					// Target player info
					LONG IP,
						 AIP,
						 MacID,
						 HwID;

					if (length <= 7)
					{
						IP		= player->player->IP;
						AIP		= player->player->IP & 0x00FFFFFF;
						MacID	= player->player->MacID;
						HwID	= (player->player->regform ? player->player->regform->HardwareID : 0);
					}
					else
					{
						parse = DATABASE.FindUser((BYTE*)&command[7]);

						if (parse)
						{
							IP		= parse->item->IP;
							AIP		= parse->item->IP & 0x00FFFFFF;
							MacID	= parse->item->MacID;
							HwID	= (parse->item->regform ? parse->item->regform->HardwareID : 0);
						}
					}

					if (parse)
					{
						if (IP == 0)
						{
							player->SendArena("This account has not been accessed yet.");

							return true;
						}

						// Output
						int Total	= 0;
						bool Found	= false;
						char buffer[256];
						memset(buffer, 0, 256);

						parse = DATABASE.UserDatabase.head;

						while (parse)
						{
							User * user = parse->item;

							if (user->IP != 0)		// IP == 0 disables alias checking
							{
								if (user->IP == IP)
								{
									if (Total) strcat(buffer, ", ");
									strcat(buffer, (char*)&user->Name[0]);
									strcat(buffer, "[IP]");
									Total++;
								}
								else if (user->MacID == MacID)
								{
									if (Total) strcat(buffer, ", ");
									strcat(buffer, (char*)&user->Name[0]);
									strcat(buffer, "[MAC]");
									Total++;
								}
								else if (user->regform && (user->regform->HardwareID == HwID))
								{
									if (Total) strcat(buffer, ", ");
									strcat(buffer, (char*)&user->Name[0]);
									strcat(buffer, "[ID2]");
									Total++;
								}
								else if ((user->IP & 0x00FFFFFF) == AIP)
								{
									if (Total) strcat(buffer, ", ");
									strcat(buffer, (char*)&user->Name[0]);
									strcat(buffer, "[~IP]");
									Total++;
								}
							}

							if (Total == 5)
							{
								player->SendArena(buffer);
								Total = 0;
								memset(buffer, 0, 256);
								Found = true;
							}

							parse = parse->next;
						}

						if (Total)
						{
							player->SendArena(buffer);
						}
						else if (Found == false)
						{
							player->SendArena("No aliases.");
						}
					}
					else
					{
						player->SendArena("Unable to find specified player.");
					}

					return true;
				}

				if (MatchString(command, "?listop", 7))
				{	// List all operators
					_listnode <Operator> * parse = DATABASE.OpDatabase.head;

					LONG Index = 0;
					_string s;

					while (parse)
					{
						Operator * op = parse->item;
						bool Allow = false;

						// Check if op is in the same sector of the biller
						if (player->OpStatus->GroupID == 0)
							Allow = true;
						else if (player->OpStatus->GroupID == op->GroupID)
						{
							if (player->OpStatus->ScoreID == 0)
								Allow = true;
							else if (player->OpStatus->ScoreID == op->ScoreID)
								Allow = true;
						}

						// Check if op has a restricted viewing level
						switch (player->OpStatus->Level)
						{
							case 2:	if (op->Level <= 0)	Allow = false;
								break;
							case 3:	if (op->Level <= 1)	Allow = false;
								break;
							case 4:	if (op->Level <= 1)	Allow = false;
								break;
						};

						// Send line if access is allowed.
						if (Allow)
						{
							Index++;
							s  = Index;
							if (op->GroupID == 0)		// Listed operator is network-wide
								s += "*";
							else if (op->ScoreID == 0)	// Listed operator is group-wide
							{
								s += "$";
							}
							s += ") ";

							if (player->OpStatus->GroupID == 0)
							{	// Needs zone/group id
								if (op->GroupID == 0)
								{	// Has nothing
								}
								else if (op->ScoreID == 0)
								{	// Has group
									s += "{";
									s += op->GroupID;
									s += "} ";
								}
								else
								{	// Has zone/group
									s += "{";
									s += op->GroupID;
									s += ":";
									Host * host = Packet->Source->Socket->FindHost(op->ScoreID);
									if (host)
										s += (char*)&host->Name[0];
									else
										s += op->ScoreID;
									s += "> ";
								}
							}
							else if (player->OpStatus->ScoreID == 0)
							{	// Needs zone
								if (op->GroupID == 0)
								{	// Has nothing
								}
								else if (op->ScoreID == 0)
								{	// Has group
								}
								else
								{	// Has zone/group
									s += "<";
									Host * host = Packet->Source->Socket->FindHost(op->ScoreID);
									if (host)
										s += (char*)&host->Name[0];
									else
										s += op->ScoreID;
									s += "> ";
								}
							}

							if (op->Owner)
								s += (char*)&op->Owner->Name[0];
							else
								s += "~guest";

							s += ":";
							s += (int) op->Level;

							if (op->LoginCounter)
							{
								s += " -> ";
								s += op->LoginCounter;
								if (op->LoginCounter == 1)
									s += " session";
								else
									s += " sessions";
							}

							player->SendArena(s.Text);
						}

						parse = parse->next;
					}

					if (!Index)
						player->SendArena("No operators.");

					return true;
				}

				if (MatchString(command, "?adduser", 8))
				{	// ?adduser Name:Password
					if (length <= 9)
					{
						player->SendArena("This command requires parameters. Type ?man adduser for details");
						return true;
					}

					BYTE Name[32];
					BYTE Password[32];
					memset(Name, 0, 32);
					memset(Password, 0, 32);

					// Parse input
					SHORT	LeftLength;
					char  * RightText;

					if (ColonParse(&command[9], length - 9, LeftLength, RightText))
					{
						// Find user
						SpaceTrim(Name, &command[9], LeftLength);
						memcpy(Password, RightText, length - LeftLength - 10);

						if (!DATABASE.FindUser(Name))
						{
							if (InvalidUsername((char*)&Name[0]))
							{
								player->SendArena("Invalid username.");
							}
							else
							{
								DATABASE.AddUser(Name, Password, 0, 0, 0);

								player->SendArena("User added.");
							}
						}
						else
						{
							player->SendArena("User already exists.");
						}
					}

					return true;
				}
			}

			/* Help commands */

			if ((DATABASE.DisableHelp == false) && MatchString(command, "?man", 4))
			{
				if (length <= 6)
				{
					if (player->player->squad && (player->player->squad->Owner == player->player))
						player->SendArena("password, details, setemail, setname, ghost, nick, seen, chat, addchat, leavechat, notifychat, squad, find, squadcreate, squadjoin, squadlist, squadleave, squadowner, squaddissolve, squadpassword, squadkick, squadgrant, squadname");
					else
						player->SendArena("password, details, setemail, setname, ghost, nick, seen, chat, addchat, leavechat, notifychat, squad, find, squadcreate, squadjoin, squadlist, squadleave, squadowner");

					if (player->OpStatus)
					{
						switch (player->OpStatus->Level)
						{
						case 0:
							player->SendArena("0: write, read, block, networkreset, changepassword, changename, changesquad");
						case 1:
							player->SendArena("1: addzone, listzone, removezone, recyclezone, changezone, closezone");
						case 2:
							player->SendArena("2: bantext, **message, extchat, notifyzone, groupid, scoreid");
						case 3:
							player->SendArena("3: addop, removeop, info");
						case 4:
							player->SendArena("4: login, changeop, listop, whois, adduser, alias, ban, listban, liftban, commentban, notifyban, dop, banfree, listbanfree, liftbanfree");
						};
					}

					player->SendArena("(Press ESC to view the entire page. ?man <command> returns detailed info)");
				}
				else
				{
					command = &command[4];

					while ((command[0] != 0) && ((command[0] == ' ') || (command[0] == '?')))
					{
						command = &command[1];
					}

					if (MatchString(command, "password", 8))
					{
						player->SendArena("  The password command allows you to change the password");
						player->SendArena("  you type when you enter the game.  Pick it wisely, as");
						player->SendArena("  it is possible to guess poorly-chosen passwords.  The");
						player->SendArena("  best passwords mix upper/lower-case letters, numbers");
						player->SendArena("  and symbols.  Limit 24 characters.");
						player->SendArena("SYNTAX: ?password=<new password>");
					}
					else if (MatchString(command, "login", 6))
					{
						player->SendArena("  Login passwords are assigned by network administrators");
						player->SendArena("  using the addop command, and may be edited with changeop.");
						player->SendArena("SYNTAX: ?login <password>");
					}
					else if (MatchString(command, "nick", 6))
					{
						player->SendArena("  This command changes your nickname in the game.  It creates");
						player->SendArena("  players on demand and uses the same login limiters as the");
						player->SendArena("  usual login process.");
						player->SendArena("SYNTAX: ?nick <name>:<password>");
					}
					else if (MatchString(command, "dop", 7))
					{
						player->SendArena("  The dop command lifts your operator status.");
						player->SendArena("SYNTAX: ?dop");
					}
					else if (MatchString(command, "addchat", 7))
					{
						player->SendArena("  The addchat command adds the given channel to the end");
						player->SendArena("  of your chat list.  Limit 9 channels.  To send chat messages");
						player->SendArena("  to channels other than #1, type |;<channel number>;message|");
						player->SendArena("SYNTAX: ?addchat=<chan>,[<chan>,<chan>,<chan>]");
					}
					else if (MatchString(command, "leavechat", 9))
					{
						player->SendArena("  To leave a single chat, use the leavechat command.  You");
						player->SendArena("  may specify a channel name or a numerical channel identifier.");
						player->SendArena("SYNTAX: ?leavechat <chat name>");
						player->SendArena("        ?leavechat <channel #>");
					}
					else if (MatchString(command, "chat", 4))
					{
						player->SendArena("  Typing |?chat| by itself will list all channels you are");
						player->SendArena("  listening to.");
						player->SendArena("SYNTAX: ?chat");
						player->SendArena("  The chat assignment command provides for reconfiguring");
						player->SendArena("  the contents and order of your chat channels.");
						player->SendArena("SYNTAX: ?chat=<chan>,[<chan>,<chan>,<chan>]");
					}
					else if (MatchString(command, "extchat", 7))
					{
						player->SendArena("  Toggle ability to receive remote chat messages from other zones.");
						player->SendArena("SYNTAX: ?extchat [yes|no]");
					}
					else if (MatchString(command, "notifychat", 7))
					{
						player->SendArena("  Using the notifychat feature enables or disables messages");
						player->SendArena("  that report when players join and exit your chat channels");
						player->SendArena("SYNTAX: ?notifychat [yes|no]");
					}
					else if (MatchString(command, "notifyban", 7))
					{
						player->SendArena("  Using the notifyban feature enables or disables messages");
						player->SendArena("  that report when banned players join and exit your network");
						player->SendArena("SYNTAX: ?notifyban [yes|no]");
					}
					else if (MatchString(command, "notifyzone", 7))
					{
						player->SendArena("  Using the notifyzone feature enables or disables messages");
						player->SendArena("  that report when zones join and exit the network");
						player->SendArena("SYNTAX: ?notifyzone [yes|no]");
					}
					else if (MatchString(command, "details", 7))
					{
						player->SendArena("  Typing |?details| alone, displays your personal details.");
						player->SendArena("SYNTAX: ?details");
						player->SendArena("  To change your details, use the details assignment command.");
						player->SendArena("SYNTAX: ?details=<personal commentary>");
						player->SendArena("  To view others' details, omit the '='.");
						player->SendArena("SYNTAX: ?details <player name>");
					}
					else if (MatchString(command, "setname", 7))
					{
						player->SendArena("  Use setname to change the name you entered in the");
						player->SendArena("  registration form.  This command does not send anything");
						player->SendArena("  to other players or network staff.  It is used solely");
						player->SendArena("  for coordinating squad league-type events.");
						player->SendArena("SYNTAX: ?setname=<real name>");
					}
					else if (MatchString(command, "setemail", 8))
					{
						player->SendArena("  Use setemail to change the address you entered in the");
						player->SendArena("  registration form.  This command does not send anything");
						player->SendArena("  to other players or network staff.  It is used solely");
						player->SendArena("  for coordinating squad league-type events.");
						player->SendArena("SYNTAX: ?setemail=<new email address>");
					}
					else if (MatchString(command, "squadjoin", 9))
					{
						player->SendArena("  To join a squad or change your squad, use squadjoin.");
						player->SendArena("SYNTAX: ?squadjoin=<squad name>:<squad password>");
						player->SendArena("  If you are a squad owner, the password is optional.");
						player->SendArena("SYNTAX: ?squadjoin=<squad name>");
					}
					else if (MatchString(command, "seen", 4))
					{
						player->SendArena("  Displays the last time at which the player was seen online.");
						player->SendArena("SYNTAX: ?seen <player name>");
					}
					else if (MatchString(command, "squadleave", 10))
					{
						player->SendArena("  When you want to leave a squad, use squadleave.  This");
						player->SendArena("  will NOT remove your status as squad leader, nor will it");
						player->SendArena("  delete the squad.");
						player->SendArena("SYNTAX: ?squadleave");
					}
					else if (MatchString(command, "squadcreate", 11))
					{
						player->SendArena("  Createsquad will create a squad and make you the owner.");
						player->SendArena("SYNTAX: ?squadcreate=<squad name>:<squad password>");
					}
					else if (MatchString(command, "squadowner", 10))
					{
						player->SendArena("  If you are unsure of who is the current owner of a squad,");
						player->SendArena("  use the squadowner command.  This works for people on or");
						player->SendArena("  off the squad.");
						player->SendArena("SYNTAX: ?squadowner <squad name>");
					}
					else if (MatchString(command, "find", 4))
					{
						player->SendArena("  The find command locates a player on the network.  It will");
						player->SendArena("  display the zone or arena he/she is in.");
						player->SendArena("SYNTAX: ?find <part of the player's name>");
						player->SendArena("  Typing |?find=:name| searches for an exact name match.  Use");
						player->SendArena("  if someone with a similar name to the searchee interferes.");
						player->SendArena("SYNTAX: ?find :<exact player name>");
					}
					else if (MatchString(command, "squaddissolve", 13))
					{
						player->SendArena("  Squaddissolve completely removes a squad from the system.");
						player->SendArena("  Players will be able to re-claim the squad afterwards.");
						player->SendArena("SYNTAX: ?squaddissolve");
					}
					else if (MatchString(command, "squadpassword", 13))
					{
						player->SendArena("  Using the squadpassword command changes your squad's password,");
						player->SendArena("  but existing squad members will not need to re-join.");
						player->SendArena("SYNTAX: ?squadpassword=<new password>");
					}
					else if (MatchString(command, "squadkick", 9))
					{
						player->SendArena("  Whenever you would like to ban a player from your squad, use");
						player->SendArena("  squadkick in combination with squadpassword to lock them out.");
						player->SendArena("SYNTAX: ?squadkick <player name>");
					}
					else if (MatchString(command, "squadgrant", 10))
					{
						player->SendArena("  Ever want to transfer zone ownership to another player?");
						player->SendArena("  Utilize squadgrant to accomplish this.");
						player->SendArena("SYNTAX: ?squadgrant <new owner's name>");
					}
					else if (MatchString(command, "squadlist", 9))
					{
						player->SendArena("  List the members of your squad.");
						player->SendArena("SYNTAX: ?squadlist");
					}
					else if (MatchString(command, "squadname", 9))
					{
						player->SendArena("  Squadname allows you to rename your squad.  Members will NOT");
						player->SendArena("  be required to re-join the squad, and the squad owner will NOT");
						player->SendArena("  be deposed.");
						player->SendArena("SYNTAX: ?squadname=<new squad name>");
					}
					else if (MatchString(command, "write", 5))
					{
						player->SendArena("  Activate the database save function.  Use sparingly.");
						player->SendArena("SYNTAX: ?write");
					}
					else if (MatchString(command, "read", 4))
					{
						player->SendArena("  Re-read SUBBILL.INI, to update biller settings without");
						player->SendArena("  a network-wide recycle.");
						player->SendArena("SYNTAX: ?read");
					}
					else if (MatchString(command, "alias", 5))
					{
						player->SendArena("  Find the other names a player has used.  Match types(in order of testing):");
						player->SendArena("  [IP]  = Exact IP match; no doubt about it.");
						player->SendArena("  [MAC] = MachineID match; this CAN be spoofed but is unlikely.");
						player->SendArena("  [ID2] = HardwareID match; experimental, thus untrustworthy.");
						player->SendArena("  [~IP] = Fuzzy IP match; there is a distinct possibility.");
						player->SendArena("SYNTAX: ?alias <player name>");
					}
					else if (MatchString(command, "adduser", 7))
					{
						player->SendArena("  Create a new user account with the given name and password.");
						player->SendArena("SYNTAX: ?adduser=<player name>:<player password>");
					}
					else if (MatchString(command, "changesquad", 11))
					{
						player->SendArena("  Change the given squad's owner.");
						player->SendArena("SYNTAX: ?changesquad=<squad name>:<new owner>");
					}
					else if (MatchString(command, "changepassword", 14))
					{
						player->SendArena("  Change the given player's password.");
						player->SendArena("SYNTAX: ?changepassword=<player name>:<new password>");
					}
					else if (MatchString(command, "changename", 10))
					{
						player->SendArena("  Change the player's name.  Score information, ban status, squad");
						player->SendArena("  ownership etc are all transferred to the new name.");
						player->SendArena("SYNTAX: ?changename=<old name>:<new name>");
					}
					else if (MatchString(command, "**", 2))
					{
						player->SendArena("  Mods use *arena. SMods use *zone. SysOps use **.");
						player->SendArena("  This command enables any zone sysop to send auto-tagged messages");
						player->SendArena("  network-wide.  The tag is not present when you are logged in");
						player->SendArena("  as billing operator level 0.");
						player->SendArena("SYNTAX: **<message>");
					}
					else if (MatchString(command, "liftbanfree", 11))
					{
						player->SendArena("  To remove a banfree, use listbanfree to retrieve the banfree number");
						player->SendArena("  and use that number with liftbanfree.");
						player->SendArena("SYNTAX: ?liftbanfree <banfree number>");
					}
					else if (MatchString(command, "listbanfree", 11))
					{
						player->SendArena("  List players who cannot be banned in the current zone.");
						player->SendArena("SYNTAX: ?listbanfree");
					}
					else if (MatchString(command, "banfree", 7))
					{
						player->SendArena("  Players who are banfreed cannot be banned in the current zone.");
						player->SendArena("SYNTAX: ?banfree <player name>");
					}
					else if (MatchString(command, "bantext", 7))
					{
						player->SendArena("  This command does NOT change player ban comments - it changes the");
						player->SendArena("  text shown when banned players enter the game in this zone.");
						player->SendArena("SYNTAX: ?bantext <new text>");
					}
					else if (MatchString(command, "ban", 3))
					{
						player->SendArena("  The ban command restricts access to your network.  Switches come");

						if (player->OpStatus)
						{
							player->SendArena("  before the player name, which is always last.  Switches:");

							switch (player->OpStatus->Level)
							{
							case 0:
								player->SendArena("  -i 127.0.*.*; -i 1.1.1.1-2.2.2.2 - Change IP range attributes.");
							case 1:
								player->SendArena("  -*        - Set a network-wide ban.");
							case 2:
								player->SendArena("  -!        - Block all traffic from his/her ISP.");
							case 3:
								player->SendArena("  -s        - Auto-ban IP subnet.  Default blocks only current IP.");
								player->SendArena("  -lvl      - Change access level needed to modify the ban. (0-4)");
							case 4:
								player->SendArena("  -k        - Do not kick the player from the zone.");
								player->SendArena("  -d=<days> - Set ban timer.");
							};
						}
						else
						{
							player->SendArena("  before the player name, which is always last.");
						}

						player->SendArena("SYNTAX: ?ban [-i IP1-IP2] [-s] [-d=7] [-k] [-*] [-!] [-level] <player name>");
					}
					else if (MatchString(command, "listban", 7))
					{
						player->SendArena("  List all bans within your sector of the network.  Bans may not be zone-wide:");
						player->SendArena("  #) <Zone Name/Zone ScoreID> Name ... - Zone-wide ban.");
						player->SendArena("  #$) {GroupID} Name ...               - Group-wide ban.");
						player->SendArena("  #*) Name ...                         - Network-wide ban.");
						player->SendArena("SYNTAX: ?listban");
					}
					else if (MatchString(command, "commentban", 10))
					{
						player->SendArena("  To add a ban comment, use listban to retrieve the ban number");
						player->SendArena("  and use that number with commentban.");
						player->SendArena("SYNTAX: ?commentban <ban number>:<comment>");
					}
					else if (MatchString(command, "liftban", 7))
					{
						player->SendArena("  To remove a ban, use listban to retrieve the ban number");
						player->SendArena("  and use that number with liftban.");
						player->SendArena("SYNTAX: ?liftban <ban number>");
					}
					else if (MatchString(command, "listzone", 8))
					{
						player->SendArena("  List all logged hosts, and display registration and connection status.");
						player->SendArena("  Online(Unregistered) - The zone has connected with the 'skeleton password'.");
						player->SendArena("                         It is advisable to use the addzone system instead.");
						player->SendArena("  Offline              - Registered with a password but not connected.");
						player->SendArena("  Online               - Registered with a password and connected.");
						player->SendArena("  Connecting: IP:Port  - Generally marks a DoS attack or unregistered zone.");
						player->SendArena("                         Methods of blocking these session types are advancing,");
						player->SendArena("                         and in most instances this is harmless.");
						player->SendArena("SYNTAX: ?listzone");
					}
					else if (MatchString(command, "closezone", 9))
					{
						player->SendArena("  To shutdown a zone, use listzone to get the zone's score id,");
						player->SendArena("  and use the id with closezone.  The zone must be connected.");
						player->SendArena("SYNTAX: ?closezone <zone score id>");
					}
					else if (MatchString(command, "recyclezone", 11))
					{
						player->SendArena("  To recycle a zone, use listzone to get the zone's score id,");
						player->SendArena("  and use the id with recyclezone.  The zone must be connected.");
						player->SendArena("SYNTAX: ?recyclezone=<zone score id>");
					}
					else if (MatchString(command, "addzone", 7))
					{
						player->SendArena("  Addzone assigns private passwords to new zones entering the");
						player->SendArena("  network.  This prevents DoS attacks by disgruntled operators");
						player->SendArena("  on other zones.  The 'skeleton key' biller password is still");
						player->SendArena("  available, but it should be randomized soon after the first");
						player->SendArena("  zone connects, as the addzone system is more efficient.");
						player->SendArena("SYNTAX: ?addzone <score id>:<password>");
					}
					else if (MatchString(command, "removezone", 10))
					{
						player->SendArena("  Removezone will unregister a zone password, but will not");
						player->SendArena("  disconnect the related zone.  To block access, use closezone");
						player->SendArena("SYNTAX: ?removezone=<score id>");
					}
					else if (MatchString(command, "changezone", 10))
					{
						player->SendArena("  Changezone changes a zone's password.  This password is,");
						player->SendArena("  incidentally, hashed on disk and in memory - thus secure.");
						player->SendArena("SYNTAX: ?changezone=<new password>");
					}
					else if (MatchString(command, "ver", 3))
					{
						player->SendArena("  This billing sysop command displays build information that");
						player->SendArena("  should remain confidential in case a version-specific");
						player->SendArena("  exploit is invented.");
						player->SendArena("SYNTAX: ?version");
					}
					else if (MatchString(command, "squad", 5))
					{
						player->SendArena("  If ever you discover the need to see what someone's squad is");
						player->SendArena("  who is not online, this is how you do it:");
						player->SendArena("SYNTAX: ?squad <player name>");
					}
					else if (MatchString(command, "ghost", 5))
					{
						player->SendArena("  The ghost command makes you invisible to the find and whois");
						player->SendArena("  commands.  Billing operators gain invisibility in chat channels.");
						player->SendArena("SYNTAX: ?ghost                                            Muahaha");
					}
					else if (MatchString(command, "whois", 6))
					{
						player->SendArena("  Retrieve player operator status.  Ghosting disables this command");
						player->SendArena("SYNTAX: ?whois <player name>");
					}
					else if (MatchString(command, "info", 4))
					{
						player->SendArena("  Shows database entry contents for given user including ban info.");
						player->SendArena("SYNTAX: ?info <player name>");
					}
					else if (MatchString(command, "scoreid", 7))
					{
						player->SendArena("  Shows current zone's score id.");
						player->SendArena("SYNTAX: ?scoreid");
					}
					else if (MatchString(command, "groupid", 7))
					{
						player->SendArena("  Shows current zone's group id.");
						player->SendArena("SYNTAX: ?groupid");
					}
					else if (MatchString(command, "group", 5))
					{
						player->SendArena("  SSBiller2 commands have varying potency depending on operator");
						player->SendArena("  level.  (Type ?man levels for info)  There is also an option");
						player->SendArena("  in the ?addop command to restrict power to a sector of the");
						player->SendArena("  network.  There are three types of restrictions:");
						player->SendArena("  Network-wide = Has power in all zones on the network");
						player->SendArena("  Group-wide   = Has power only in one GroupID [See SERVER.INI]");
						player->SendArena("  Zone-wide    = Has power only in one zone.  In listops, these");
						player->SendArena("                 operators have the name or ScoreID of the zone");
					}
					else if (MatchString(command, "level", 5))
					{
						player->SendArena("  SSBiller2 uses an access-system for operators based on zone");
						player->SendArena("  ScoreID and GroupID.  (Type ?man groups for info)");
						player->SendArena("  Operator levels are independant of these restrictions.");
						player->SendArena("  0 = Network Administrator");
						player->SendArena("  1 = Zone Host or Group Manager");
						player->SendArena("  2 = Zone SysOp");
						player->SendArena("  3 = Zone Super Moderator");
						player->SendArena("  4 = Zone Moderator");
					}
					else if (MatchString(command, "addop", 5))
					{
						player->SendArena("  ?login <password> can be set to allow private passwords using");
						player->SendArena("  the addop command.  Type ?man levels or ?man groups for more info.");
						player->SendArena("  The operator's zone is the current one.  Switches:");
						player->SendArena("  -*         = Network-wide");
						player->SendArena("  -g         = Group-wide within current group");
						player->SendArena("  -g=GroupID = Group-wide within given group");
						player->SendArena("  -level     = Operator level (0-4)");
						player->SendArena("SYNTAX: ?addop [-*] [-level] [-g] [-g=group] <name>:<password>");
					}
					else if (MatchString(command, "listop", 6))
					{
						player->SendArena("  List registered operators.  Type ?man level or ?man group for info.");
						player->SendArena("  #*) Name ... - Network-wide operator.");
						player->SendArena("  #$) Name ... - Group-wide operator.");
						player->SendArena("SYNTAX: ?listop");
					}
					else if (MatchString(command, "changeop", 8))
					{
						player->SendArena("  The changeop command allows you to change an operator's password.");
						player->SendArena("  Type ?man levels or ?man groups for more info.  For SMod+..");
						player->SendArena("SYNTAX: ?changeop <operator entry #>:<new password>");
						player->SendArena("  When you are a moderator, however, you are only permitted to change");
						player->SendArena("  your own password, and so the operator entry # is omitted..");
						player->SendArena("SYNTAX: ?changeop <new password>");
					}
					else if (MatchString(command, "removeop", 8))
					{
						player->SendArena("  The removeop command deletes an operator's private ?login password.");
						player->SendArena("  Type ?man levels or ?man groups for more info.");
						player->SendArena("SYNTAX: ?removeop <operator entry #>");
					}
					else if (MatchString(command, "block", 5))
					{
						player->SendArena("  Toggles between the Block states:");
						player->SendArena("    Normal  - No special treatment.");
						player->SendArena("    Banfree - Pass bans and some other blocks.");
						player->SendArena("SYNTAX: ?block <player name>");
					}
					else if (MatchString(command, "man", 3))
					{
						player->SendArena("  Moo.  Moo, moo.  Moo; moo moo.");
						player->SendArena("SYNTAX: ?moo=<moo>:<moo>");
					}
					else if (MatchString(command, "help me", 2))
					{
						player->SendArena("  For starters, stop playing SubSpace.  Then, pat yourself");
						player->SendArena("  on the back.  We'd do it for you if we weren't just programmed");
						player->SendArena("  auto-responses.  Finally, sit down and read a good book.");
						player->SendArena("  I recommend anything by Stephen Baxter.");
						player->SendArena("  Remember: You are important, even though noone cares.");
					}
					else if (MatchString(command, "help yourself", 8))
					{
						player->SendArena("  I try.  But, being part of a single-state machine does not help.");
					}
					else
					{
						player->SendArena("  Help in this catagory is unavailable.");
					}
				}

				return true;
			}

			/* Diagnostic commands */

			if (MatchString(command, "?find", 5))
			{
				if (length <= 6)
				{
					player->SendArena("This command requires parameters. Type ?man find for details");

					return true;
				}

				if (command[6] == ':')
				{
					_listnode <Host> * parse = (Packet->Source->Socket)->HostList.head;
					int Counter = 0;

					while (parse)
					{
						// Find user
						_listnode <LUserNode> * user = parse->item->Find(&command[7], true);

						if (user && !user->item->Ghost)
						{
							// Prepare response
							char buffer[512];

							strcpy(buffer, (char*)&user->item->player->Name[0]);
							strcat(buffer, " is in ");
							strcat(buffer, (char*)&user->item->zone->Name[0]);

							// Send it
							player->SendArena(buffer);
							Counter++;

							if (Counter > 5)
								return true;
						}

						// Try next zone
						parse = parse->next;
					}

					if (Counter == 0)
						player->SendArena("User offline");
				}
				else
				{
					_listnode <Host> * parse = (Packet->Source->Socket)->HostList.head;
					int Counter = 0;

					while (parse)
					{
						// Find user
						if (parse->item != Packet->Source)
						{
							_listnode <LUserNode> * user = parse->item->Find(&command[6], false);

							if (user && !user->item->Ghost)
							{
								// Prepare response
								char buffer[512];

								strcpy(buffer, (char*)&user->item->player->Name[0]);
								strcat(buffer, " is in ");
								strcat(buffer, (char*)&user->item->zone->Name[0]);

								// Send it
								player->SendArena(buffer);
								Counter++;

								if (Counter > 5)
									return true;
							}
						}

						// Try next zone
						parse = parse->next;
					}

					if (Counter == 0)
						player->SendArena("User offline");
				}

				return true;
			}

#ifdef ERROR_TRAPPER

}
catch (...)		// catch any kind of error
{
	printf("%i - Command crash attempt by %s -> '%s'\n", Packet->Source->ScoreID, player->player->Name, command);
	player->SendArena("Congrats!  You managed to crash the billing server.  Report circumstances to Catid@pacbell.net");
}

#endif

	}
	else
	{
		// Does not

		printf("%i - (INVALID)>%s\n", Packet->Source->ScoreID, &Packet->Message[5]);
	}

	return true;
}
